SystemOrganization addCategory: #Familiar!
SystemOrganization addCategory: #'Familiar-SPINE'!
SystemOrganization addCategory: #'Familiar-SPINE-Moose'!
SystemOrganization addCategory: #'Familiar-SPINE-Tests'!
SystemOrganization addCategory: #'Familiar-Core'!
SystemOrganization addCategory: #'Familiar-Tests'!
SystemOrganization addCategory: #'Familiar-Moose'!
SystemOrganization addCategory: #'Familiar-Visitor'!

MooseGroup subclass: #FMAssignmentGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMAssignmentGroup commentStamp: '<historical>' prior: 0!
MooseModel resetMeta!

!FMAssignmentGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 15:44'!
annotation

	<MSEClass: #AssignmentGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMAssignmentGroup methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:12'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>
	
	"Preambule. It includes the initialization. "
	| view assignments |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"
	self viewComplexityOn: view.
	"-------------"
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

!FMAssignmentGroup methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:15'!
viewComplexityOn: view

"	(assignments anySatisfy:  [ :ass | ass featureModel numberOfConstraints > 0])
		ifTrue: 
			[ view shape rectangle 
				linearFillColor: [ :ass | ass featureModel numberOfConstraints] within: assignments ]."
	
	 self do: [:ass | ass viewComplexityOn: view ].
! !

MooseGroup subclass: #FMFeatureGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMFeatureGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 14:29'!
annotation

	<MSEClass: #FeatureGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMFeatureGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/2/2012 14:59'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>

	"Preambule. It includes the initialization. "
	| view nodes |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"

	nodes := self asArray.
	view interaction action: #inspect; popupText.

	view nodes: nodes.
	view edges: nodes from: #yourself toAll:  #subFeatures.
	view treeLayout.
	"-------------" 
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

MooseGroup subclass: #FMFeatureModelGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMFeatureModelGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 01:12'!
annotation

	<MSEClass: #FeatureModelGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMFeatureModelGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 16:58'!
setInteractionOfNodes: view
	view interaction 
			popupText: #description.! !

!FMFeatureModelGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/3/2012 13:24'!
viewDistribution
	<menuItem: 'Distribution' category: 'Visualize'>
	
	| view | 
	view := MOViewRenderer new.
	view shape rectangle 
			width: [ :fm | fm numberOfProductions * 5 ];
			height: [ :fm | fm numberOfConstraints * 5 ].
	
	self setInteractionOfNodes: view.
	view nodes: self entities.
	^ view openWithStatusbar title: 'Class Blueprint'! !

MooseGroup subclass: #SPDomainElementGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Moose'!

!SPDomainElementGroup methodsFor: 'as yet unclassified' stamp: 'SimonUrli 11/27/2012 18:35'!
visualize
	<menuItem: 'Spine Domain Element' category: 'Visualize'> 
	
	| view rawView |
	rawView := ROView new.
	view := ROMondrianViewBuilder view:rawView.
	self visualizeOn: view.
	ROEaselMorphic new populateMenuOn: view.
	view openInWindowSized: 1024 @ 768.
	! !

!SPDomainElementGroup methodsFor: 'as yet unclassified' stamp: 'SimonUrli 11/28/2012 11:08'!
visualizeOn: view
	| nodes elements rawView assoNodes |
	rawView := view raw.
	view shape rectangle
		fillColor:
			(RONColorLinearNormalizer
				inContext: (self mooseModel allWithType: SPDEAssociation) asArray
				withCommand: #numberOfRules
				lowColor: Color white
				highColor: Color red).
	assoNodes := (self mooseModel allWithType: SPDEAssociation) asArray.
	view interaction
		popupText: [ :a | 
			 a getDescription, (String with: Character cr) , 'Functions: '
				, a restrictionFunctions size printString , (String with: Character cr) , 'Rules: ' , a numberOfRules printString ].
	view
		nodes: assoNodes
		forEach: [ :asso | 
			view shape label text: #getDescription.
			view interaction forward.
			view node: asso.
			view nodes: asso restrictionFunctions forEach: [: rf |
				view nodes: rf rules.
				view gridLayout.
			].
			view flowLayout.
		].
	view
		nodes: self asArray
		forEach: [ :de | 
			view shape label text: #name.
			view interaction forward.
			view node: de.
			view shape rectangle borderColor: Color white.
			view interaction forward.
			view
				nodes: de refersOn
				forEach: [ :element | 
					view interaction
						on: ROMouseEnter
						do: [ :el | 
							| nodesToHL |
							nodesToHL := view raw elementsFromModels: el element model launchActionsOnFeatures.
							ROHighlightElements on: nodesToHL color: Color blue ].
					view interaction
						on: ROMouseLeave
						do: [ :el | 
							| nodesToHL |
							nodesToHL := view raw elementsFromModels: el element model launchActionsOnFeatures.
							ROUnhighlightElements on: nodesToHL ].
					view interaction
						popupText: [ :feat | 
							feat name , (String with: Character cr) , 'Internal constraints: ' , feat numberOfLocalConstraints printString
								, (String with: Character cr) , 'Launch ' , feat launchActionsOnFeatures size printString , ' actions'
								, (String with: Character cr) , 'Affected by: ' , feat isLaunchedByFeatures size printString , ' features' ].
					view interaction
						on: ROMouseLeftClick
						do: [ :el | el model visualize ].	"view interaction item: 'focus on it' action: [ :el | el model visualize ]."	""
					view shape rectangle
						width: [ :f | f numberOfActions * 10 ];
						height: [ :f | f numberOfConfigurationStates * 10 ];
						linearFillColor: #numberOfLocalConstraints within: (self mooseModel allWithType: SPFeature) asArray.
					nodes := element features.
					view nodes: nodes.
					view edges: nodes from: #yourself toAll: #featureChildren.
					view treeLayout ].
			view verticalLineLayout ].
	
	assoNodes
		do: [ :asso | 
			| node targetNode sourceNode targetEdge sourceEdge |
			node := view raw elementFromModel: asso.
			targetNode := view raw elementFromModel: asso target first applyOn first.
			targetEdge := ROEdge from: node to: targetNode.
			targetEdge + ((ROLine red width: 2) addBegining: ROArrow new).
			view raw add: targetEdge.
			sourceNode := view raw elementFromModel: asso source first applyOn first.
			sourceEdge := ROEdge from: sourceNode to: node.
			sourceEdge + (ROLine red width: 2).
			view raw add: sourceEdge ].
	view gridLayout.! !

MooseGroup subclass: #SPFeatureGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Moose'!

!SPFeatureGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 11/23/2012 12:08'!
visualizeSPINE
	<menuItem: 'Spine Feature System' category: 'Visualize'> 
	
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeSPINEOn: view.
	view open.! !

!SPFeatureGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 11/23/2012 12:16'!
visualizeSPINEOn: view

	view shape rectangle
		width: [ :f | f numberOfActions * 10 ];
		height: [ :f | f numberOfConfigurationStates * 10 ].
		
	view nodes: self asArray.
	
	view gridLayout ! !

MooseGroup subclass: #SPFeatureModelGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Moose'!

!SPFeatureModelGroup methodsFor: 'visualization' stamp: 'SimonUrli 11/23/2012 16:13'!
visualizeSPINE
	<menuItem: 'Spine Feature Model System' category: 'Visualize'> 
	
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeSPINEOn: view.
	view open.! !

!SPFeatureModelGroup methodsFor: 'visualization' stamp: 'SimonUrli 11/23/2012 16:06'!
visualizeSPINEOn: view

	view shape rectangle
		width: [ :f | f numberOfActions * 10 ];
		height: [ :f | f numberOfConfigurationStates * 10 ].
		
	view nodes: (self asArray) forEach:[:element |
		view shape rectangle
			width: [ :f | f numberOfActions * 10 ];
			height: [ :f | f numberOfConfigurationStates * 10 ].
		view nodes: element features.
	].
	
	view gridLayout ! !

MooseEntity subclass: #FMObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMObject subclass: #FMConstraintExpr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMConstraintExpr subclass: #FMConstraintBinOp
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMConstraintBinOp subclass: #FMConstraintAnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintAnd class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '&'! !

!FMConstraintAnd class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	^ 'and'! !

!FMConstraintAnd methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintAnd: self.
	super accept: aVisitor! !

FMConstraintBinOp subclass: #FMConstraintArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintArrow class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '->'! !

!FMConstraintArrow methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:40'!
accept: aVisitor
	aVisitor visitConstraintArrow: self.
	super accept: aVisitor! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:26'!
for: string
	"Return the class that correspond to the string. 
	We here assume that all the subclasses have a distint operator"
	^ self allSubclasses detect: [:cls | (cls operator = string) or: [ cls operator2 = string ] ]! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 10:00'!
operator
	^ self subclassResponsibility ! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	"Express the alternative of operator, for example or | and and &"
	^ self operator! !

!FMConstraintBinOp methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor

	left accept: aVisitor.
	right accept: aVisitor.! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 09:58'!
features
	"Return the list of features that are recursively obtained from myself"
	
	| v |
	v := CountingFeatureVisitor new.
	self accept: v.
	^ v features! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:01'!
left
	^ left! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:01'!
left: anObject
	left := anObject! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:02'!
right
	^ right! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:02'!
right: anObject
	right := anObject! !

FMConstraintBinOp subclass: #FMConstraintEquiv
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintEquiv class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '<->'! !

!FMConstraintEquiv methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintEquiv: self.
	super accept: aVisitor! !

FMConstraintBinOp subclass: #FMConstraintPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintPipe class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '|'! !

!FMConstraintPipe class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	^ 'or'! !

!FMConstraintPipe methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintPipe: self.
	super accept: aVisitor! !

!FMConstraintExpr methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:27'!
accept: aVisitor
	self subclassResponsibility ! !

FMConstraintExpr subclass: #FMConstraintNegated
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintNegated methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintNegated: self.
	expr accept: aVisitor! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:05'!
expr
	^ expr! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:05'!
expr: anObject
	expr := anObject! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:23'!
features
	^ expr features! !

FMObject subclass: #FMFeature
	instanceVariableNames: 'name featureModel kind constraintsCache subFeaturesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeature class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/2/2012 11:01'!
named: aName
	^ self new name: aName; yourself! !

!FMFeature methodsFor: 'equality' stamp: 'AlexandreBergel 11/23/2012 09:59'!
= aFeature
	^ (self name = aFeature name) 
	"^ (self name = aFeature name) and: [ self featureModel == aFeature featureModel ]"! !

!FMFeature methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:13'!
accept: aVisitor 
	aVisitor visitFeature: self! !

!FMFeature methodsFor: 'navigating' stamp: 'AlexandreBergel 7/4/2012 14:37'!
constrainedFeatures
	<navigation: 'constrained features'>
	^ ((self constraints inject: #() into: [ :sum :c | sum , c features ]) asSet asArray) copyWithout: self! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:11'!
constraints
	"Return the list of constraints in which I am involved"
	
	constraintsCache ifNotNil: [ ^ constraintsCache ].
	^ constraintsCache := featureModel constraintsContainingFeature: self! !

!FMFeature methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 13:32'!
constraintsInfo
	| str |
	
	str := WriteStream on: String new.
	(self impliedBy copyFrom: 1 to: (self impliedBy size min: 5)) do: [ :f | 
		str nextPutAll: String cr.
		str nextPutAll: f name, ' -> '
		].
	(self impliedBy size > 5) ifTrue: [ 
		str nextPutAll: String cr.
		str nextPutAll: '... (', self impliedBy size printString, ')'		
	].

	(self implying copyFrom: 1 to: (self implying size min: 5))  do: [ :f | 
		str nextPutAll: String cr.
		str nextPutAll:  ' -> ', f name
		].
	(self implying size > 5) ifTrue: [ 
		str nextPutAll: String cr.
		str nextPutAll: '... (', self implying size printString, ')'	
	].
	^ str contents! !

!FMFeature methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 17:03'!
description

	| v |
	self isOr ifTrue: [ v := ' or' ].
	self isXor ifTrue: [ v := ' xor' ].
	self isMandatory ifTrue: [ v := ' mendatory' ].
	self isMutex ifTrue: [ v := ' mutex' ].
	self isOptional ifTrue: [ v := ' optional' ].	 

	^ ' Feature ', self name, v, self constraintsInfo! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 16:40'!
exclusions
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v exclusions! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:11'!
featureModel
	"Return the feature model that defines me"
	
	^ featureModel! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:25'!
featureModel: fm
	featureModel := fm! !

!FMFeature methodsFor: 'equality' stamp: 'AlexandreBergel 7/2/2012 11:00'!
hash
	^ self name hash! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/4/2012 17:27'!
impliedBy
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v featuresImplied! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/4/2012 17:27'!
implying
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v featuresImplying! !

!FMFeature methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/3/2012 17:14'!
initialize 
	"We say that per default, a feature is mendatory. Actually, the kind variable is always set"

	super initialize.
	kind := FMFeatureMendatory new! !

!FMFeature methodsFor: 'visiting' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory
	^ kind isMandatory! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isMutex
	^ kind isMutex! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isOptional
	^ kind isOptional! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isOr
	^ kind isOr! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isXor
	^ kind isXor! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
kind
	"return the instance of FMFeatureExpr that says whether I am mendatory, mutex, or, xor, or optional"

	^ kind! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 18:10'!
kind: anObject
	kind := anObject! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
name
	"My name"
	^ name! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
name: aString
	"My name"
	name := aString! !

!FMFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 7/3/2012 17:14'!
numberOfConstraints
	"Return the number of constraints in which I am involved"
	
	^ self constraints size! !

!FMFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 7/6/2012 17:34'!
numberOfExclusions 
	^ self exclusions size! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 11:45'!
numberOfFeaturesImpliedBy
	^ self impliedBy size
! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 11:42'!
numberOfFeaturesImplying
	^ self implying size! !

!FMFeature methodsFor: 'navigating' stamp: 'AlexandreBergel 7/3/2012 14:14'!
subFeatures
	<navigation: 'sub features'>
	subFeaturesCache ifNotNil: [ ^ subFeaturesCache ].
  
	^ subFeaturesCache := featureModel subFeaturesOf: self! !

FMObject subclass: #FMFeatureExpr
	instanceVariableNames: 'feature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureExpr methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:15'!
accept: aVisitor
	feature accept: aVisitor
	! !

!FMFeatureExpr methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 10:57'!
feature
	^ feature! !

!FMFeatureExpr methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 18:10'!
feature: aFeature
	feature := aFeature.
	aFeature kind: self.! !

!FMFeatureExpr methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isMutex
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isOptional
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isOr
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isXor
	^ false! !

!FMFeatureExpr methodsFor: 'printing' stamp: 'AlexandreBergel 7/1/2012 10:45'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	id ifNotNil: [ str nextPutAll: id ].
	str nextPut: $>.! !

FMFeatureExpr subclass: #FMFeatureMendatory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureMendatory methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory 
	^ true! !

FMFeatureExpr subclass: #FMFeatureMutex
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureMutex methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isMutex 
	^ true! !

FMFeatureExpr subclass: #FMFeatureOptional
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureOptional methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isOptional 
	^ true! !

FMFeatureExpr subclass: #FMFeatureOr
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureOr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isOr
	^ true! !

FMFeatureExpr subclass: #FMFeatureXor
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureXor methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isXor
	^ true! !

FMObject subclass: #FMFeatureModel
	instanceVariableNames: 'exprs constraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureModel methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 10:45'!
accept: aVisitor 
	aVisitor visitFeatureModel: self.
	exprs do: [ :expr | expr accept: aVisitor ]. 
	constraints do: [ :cons | cons accept: aVisitor ].! !

!FMFeatureModel methodsFor: 'adding' stamp: 'AlexandreBergel 7/2/2012 13:25'!
addAllConstraints: cons
	self assert: [ cons isCollection ].
	self assert: [ cons isEmpty or: [ cons first isKindOf: FMConstraintExpr ] ].
	constraints addAll: cons! !

!FMFeatureModel methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 15:22'!
addAllExpressions: exps
	exprs addAll: exps! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 14:50'!
constraintAt: index
	^ constraints at: index! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 09:51'!
constraintsContainingFeature: aFeature
	
	| v |
	^ self constraintsSelect: [ :cons | 
		cons features anySatisfy: [ :f | f name = aFeature name ] ]! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 15:00'!
constraintsInfo
	^ ''! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 14:34'!
constraintsSelect: aBlock
	^ constraints select: aBlock! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:44'!
featureNamed: aName 
	^ self features detect: [ :f | f name = aName ]! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:28'!
features
	| v |
	v := CountingFeatureVisitor new.
	self accept: v.
	v features do: [ :f | f featureModel: self ].
	^ v features! !

!FMFeatureModel methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 14:26'!
initialize 
	super initialize.
	exprs := OrderedCollection new.
	constraints := OrderedCollection new! !

!FMFeatureModel methodsFor: 'printing' stamp: 'AlexandreBergel 7/2/2012 14:15'!
mooseNameOn: str 

	str nextPutAll: 'FM ('.
	exprs
		do: [ :expr | str nextPutAll: expr root name ].
	str nextPutAll: ')'.
	^ str contents! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:59'!
numberOfConstraints
	<MSEProperty: #numberOfConstraints type: #Number>
	^ constraints size! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 10:41'!
numberOfFeatures
	^ self features size! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:59'!
numberOfProductions
	<MSEProperty: #numberOfProductions type: #Number>
	^ exprs size! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 14:50'!
productionAt: index
	^ exprs at: index! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:49'!
setInteractionOfFeature: view
	view interaction 
			popupText: #description;
	
			item: 'constrained features' action: [ :f | f constrainedFeatures inspect ];
			item: 'inspect' action: #inspect;
			item: 'implications' action: [ :e | self visualizeImplications ];
						
			highlightWhenOver: #implying color: Color lightBlue;
			highlightWhenOver: #impliedBy color: Color blue;
			highlightWhenOver: #exclusions color: Color red.
			"highlightWhenOver: #constrainedFeatures color: Color green"! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:45'!
subFeaturesOf: aFMFeature 
	^ ((exprs detect: [ :prod | prod root = aFMFeature ] ifNone: [ ^ #() ] ) allChildren collect: #feature) asArray! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:46'!
viewComplexityOn: view

	view node: self forIt: [		
		view shape rectangle 
			"size:  [ :f | f numberOfConstraints * 3 ];"
			height: [ :f | f numberOfFeaturesImplying * 3 ];
			width: [ :f | f numberOfFeaturesImpliedBy * 3 ]; 
			borderWidth: [ :f |  f numberOfExclusions max: 1 ];
			if: #isMandatory fillColor: Color white;
			if: #isOr fillColor: Color pink;
			if: #isMutex fillColor: Color lightYellow;
			if: #isOptional fillColor: Color lightGray;
			if: #isXor fillColor: Color yellow.
		self setInteractionOfFeature: view.
		view nodes: self features.
					
		view edges: self features from: #yourself toAll: #subFeatures.
		view treeLayout ].
	! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:46'!
visualizeImplications
	| view |
	view := ROMondrianViewBuilder new.
	
	view shape rectangle 
			"size:  [ :f | f numberOfConstraints * 3 ];"
			height: [ :f | f numberOfFeaturesImplying * 3 ];
			width: [ :f | f numberOfFeaturesImpliedBy * 3 ]; 
			borderWidth: [ :f |  f numberOfExclusions max: 1 ];
			if: #isMandatory fillColor: Color white;
			if: #isOr fillColor: Color pink;
			if: #isMutex fillColor: Color lightYellow;
			if: #isOptional fillColor: Color lightGray;
			if: #isXor fillColor: Color yellow.
			
	view nodes: self features.
	
	view shape arrowedLineWithOffset: 0.3; color: Color green.
	view edges: self features from: #yourself toAll: #implying.

	view shape line color: Color red.
	view edges: self features from: #yourself toAll: #exclusions.

	view circleLayout .
	view open! !

FMObject subclass: #FMFeatureProduction
	instanceVariableNames: 'root children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureProduction methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 10:50'!
accept: aVisitor
	root accept: aVisitor.
	children do: [ :child | child accept: aVisitor ] ! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:32'!
addAll: featureExpressions
	self assert: [ featureExpressions isCollection ].

	children addAll: featureExpressions! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:43'!
allChildren
	^ children copy! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:37'!
childAt: index
	^ children at: index! !

!FMFeatureProduction methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 10:32'!
initialize
	super initialize.
	children := OrderedCollection new! !

!FMFeatureProduction methodsFor: 'metrics' stamp: 'AlexandreBergel 7/1/2012 10:37'!
numberOfChildren
	^ children size! !

!FMFeatureProduction methodsFor: 'printing' stamp: 'AlexandreBergel 7/1/2012 15:23'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	id ifNotNil: [ str nextPutAll: root ].
	str nextPut: $>.! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:31'!
root
	^ root! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:31'!
root: anObject
	root := anObject! !

!FMObject methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/23/2012 09:22'!
resolve! !

FMObject subclass: #FMProgram
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMProgram methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:03'!
accept: aVisitor
	aVisitor visitProgram: self.
	self statements do: [ :s | s accept: aVisitor ]! !

!FMProgram methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 14:57'!
add: aStatement
	statements add: aStatement ! !

!FMProgram methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 15:06'!
addAll: ss
	ss do: [ :s | self add: s ]! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 15:09'!
featureNamed: aName
	| v t |
	v := CollectingVisitor new.
	self accept: v.
	t := (v elementsOfKind: FMFeature) select: [ :f | f name = aName ] .
	self assert: [ t size =  1 ].
	^ t first! !

!FMProgram methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 14:57'!
initialize
	super initialize.
	statements := OrderedCollection new! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 16:24'!
lastStatement 
	^ statements last! !

!FMProgram methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:58'!
numberOfStatements
	<MSEProperty: #numberOfStatements type: #Number>
	^ statements size! !

!FMProgram methodsFor: 'metrics' stamp: 'AlexandreBergel 7/3/2012 16:56'!
numberOfVariables
	^ (self statements collect: #variable) asSet size! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:08'!
statementAt: index
	^ statements at: index! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 00:14'!
statements
	^ statements copy! !

FMObject subclass: #FMStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMStatement subclass: #FMAssignment
	instanceVariableNames: 'variable featureModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMAssignment methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:16'!
accept: aVisitor
	aVisitor visitAssigment: self.
	
	aVisitor visitVariable: variable.
	featureModel accept: aVisitor.! !

!FMAssignment methodsFor: 'navigating' stamp: 'AlexandreBergel 7/2/2012 00:57'!
featureModel
	<navigation: 'Feature model'>
	^ featureModel! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
featureModel: anObject
	featureModel := anObject! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 11:35'!
mooseFinderComplexityIn: composite
	<moosePresentationOrder: 20>
	
	composite roassal 
			title: 'Complexity';
			titleIcon: MooseIcons mooseBlueprint;
			painting: [ :view :each | each mooseInterestingEntity viewComplexityOn: view ]! !

!FMAssignment methodsFor: 'printing' stamp: 'AlexandreBergel 7/2/2012 00:49'!
mooseNameOn: str
	str nextPutAll: variable! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 16:59'!
setInteractionOfNodes: view
	view interaction 
			popupText: #description;

			item: 'constrained features' action: [ :f | f constrainedFeatures inspect ];
			highlightWhenOver: #impliedBy color: Color green! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
variable
	^ variable! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
variable: anObject
	variable := anObject! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:14'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>

	"Preambule. It includes the initialization. "
	| view assignments |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"
	self viewComplexityOn: view.
	"-------------"
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 11:39'!
viewComplexityOn: view
	| fm |

	view interaction popupText: self variable; action: #inspect.
	featureModel viewComplexityOn: view.
! !

MooseEntity subclass: #SPObject
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

SPObject subclass: #SPAbstractAction
	instanceVariableNames: 'fm feature rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
feature
	^ feature! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
feature: anObject
	feature := anObject! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
fm
	^ fm! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
fm: anObject
	fm := anObject! !

!SPAbstractAction methodsFor: 'resolving dependencies' stamp: 'SimonUrli 11/26/2012 15:34'!
resolve
	fm := fm collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ fm allSatisfy: [ :obj | obj isKindOf: SPFeatureModel ] ].

	feature  := feature collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ feature allSatisfy: [ :obj | obj isKindOf: SPFeature ] ].
	
! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 15:33'!
rule
	^ rule! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 15:33'!
rule: anObject
	rule := anObject! !

SPAbstractAction subclass: #SPActionDeselect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

SPAbstractAction subclass: #SPActionSelect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

SPObject subclass: #SPConfigurationState
	instanceVariableNames: 'fm selected deselected rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:54'!
deselected
	^ deselected! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:54'!
deselected: anObject
	deselected := anObject! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:55'!
fm
	^ fm! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:55'!
fm: anObject
	fm := anObject! !

!SPConfigurationState methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/23/2012 09:10'!
resolve
	selected  := selected collect: [ :idName | self mooseModel entityNamed: idName ].
	"self assert: [ selected allSatisfy: [ :obj | obj isKindOf: FMFeature ] ]."

	deselected  := deselected collect: [ :idName | self mooseModel entityNamed: idName ].
	"self assert: [ deselected allSatisfy: [ :obj | obj isKindOf: FMFeature ] ]."
	
	fm := fm collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ fm allSatisfy: [ :obj | obj isKindOf: SPFeatureModel ] ].! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 15:36'!
rule
	^ rule! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 15:36'!
rule: anObject
	rule := anObject! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:54'!
selected
	^ selected! !

!SPConfigurationState methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:54'!
selected: anObject
	selected := anObject! !

SPObject subclass: #SPDEAssociation
	instanceVariableNames: 'source target restrictionFunctions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPDEAssociation methodsFor: 'accessing' stamp: 'SimonUrli 11/28/2012 10:53'!
getDescription
	^self source first applyOn first name , '->' , self target first applyOn first name! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'SimonUrli 11/27/2012 18:52'!
numberOfRules
	| total |
	total := 0.
	self restrictionFunctions do: [:rf | total := total + rf rules size].
	^total! !

!SPDEAssociation methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/23/2012 09:11'!
resolve
	source  := source collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ source allSatisfy: [ :obj | obj isKindOf: SPDomainElementEnd ] ].

	target  := target collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ target allSatisfy: [ :obj | obj isKindOf: SPDomainElementEnd ] ].
	
	restrictionFunctions := restrictionFunctions collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ restrictionFunctions allSatisfy: [ :obj | obj isKindOf: SPRestrictionFunction ] ].! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
restrictionFunctions
	^ restrictionFunctions! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
restrictionFunctions: anObject
	restrictionFunctions := anObject! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
source
	^ source! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
source: anObject
	source := anObject! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
target
	^ target! !

!SPDEAssociation methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:03'!
target: anObject
	target := anObject! !

SPObject subclass: #SPDomainElement
	instanceVariableNames: 'belongsTo refersOn multiplicityElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPDomainElement methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:42'!
associatedDomainElements
	| listeDESource |
	listeDESource := self belongsTo collect: [ :asso | asso source first applyOn first ].
	^ listeDESource select: [:de | de ~~ self]. ! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
belongsTo
	^ belongsTo! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
belongsTo: anObject
	belongsTo := anObject! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:53'!
multiplicityElement
	^ multiplicityElement! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:53'!
multiplicityElement: anObject
	multiplicityElement := anObject! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
refersOn
	^ refersOn! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
refersOn: anObject
	refersOn := anObject! !

!SPDomainElement methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/23/2012 09:12'!
resolve
	refersOn  := refersOn collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ refersOn allSatisfy: [ :obj | obj isKindOf: SPFeatureModel ] ].

	multiplicityElement  := multiplicityElement collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ multiplicityElement allSatisfy: [ :obj | obj isKindOf: SPMultiplicityElement ] ].
	
	belongsTo := belongsTo collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ belongsTo allSatisfy: [ :obj | obj isKindOf: SPDEAssociation ] ].! !

SPObject subclass: #SPDomainElementEnd
	instanceVariableNames: 'applyOn linkMultiplicity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
applyOn
	^ applyOn! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
applyOn: anObject
	applyOn := anObject! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
linkMultiplicity
	^ linkMultiplicity! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
linkMultiplicity: anObject
	linkMultiplicity := anObject! !

!SPDomainElementEnd methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/23/2012 09:02'!
resolve
	applyOn := applyOn collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ applyOn allSatisfy: [ :obj | obj isKindOf: SPDomainElement ] ].
	
	linkMultiplicity := linkMultiplicity collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ linkMultiplicity allSatisfy: [ :obj | obj isKindOf: SPMultiplicityElement ] ].! !

SPObject subclass: #SPFeature
	instanceVariableNames: 'fmFeature shortName featureModel featureChildren'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/26/2012 17:26'!
actions
	^ (self deselectedActions),(self selectedActions)! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:34'!
configurationDeselectedStates
	^ (self mooseModel allWithType: SPConfigurationState) select: [ :config | config deselected includes: self ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:34'!
configurationSelectedStates
	^ (self mooseModel allWithType: SPConfigurationState) select: [ :config | config selected includes: self ]! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/26/2012 15:57'!
configurationStates
	^ (self mooseModel allWithType: SPConfigurationState) select: [ :config | (config deselected includes: self) | (config selected includes: self) ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:38'!
deselectedActions
	^ (self mooseModel allWithType: SPActionDeselect) select: [ :action | action feature includes: self ]! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 10:45'!
featureChildren
	^ featureChildren! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 10:45'!
featureChildren: anObject
	featureChildren := anObject! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 10:13'!
featureModel
	^ featureModel! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/26/2012 10:13'!
featureModel: anObject
	featureModel := anObject! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:29'!
fmFeature
	^ fmFeature! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:29'!
fmFeature: anObject
	fmFeature := anObject! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/28/2012 11:30'!
isDeselectedByFeaturesDeselected
	| cs selected deselected retour rules |
	rules := self deselectedActions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray flatten.
	deselected := (cs collect: [:c | c deselected ]) asArray flatten.
	retour := deselected.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/28/2012 11:30'!
isDeselectedByFeaturesSelected
	| cs selected deselected retour rules |
	rules := self deselectedActions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray flatten.
	selected := (cs collect: [:c | c selected ]) asArray flatten.
	retour := selected.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/27/2012 16:45'!
isLaunchedByFeatures
	| cs selected deselected retour rules |
	rules := self actions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray flatten.
	selected := (cs collect: [:c | c selected ]) asArray flatten.
	deselected := (cs collect: [:c | c deselected ]) asArray flatten.
	retour := selected,deselected.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/28/2012 11:30'!
isSelectedByFeaturesDeselected
	| cs selected deselected retour rules |
	rules := self selectedActions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray flatten.
	deselected := (cs collect: [:c | c deselected ]) asArray flatten.
	retour := deselected.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/28/2012 11:29'!
isSelectedByFeaturesSelected
	| cs selected deselected retour rules |
	rules := self selectedActions collect: [:a | a rule].
	cs := rules collect: [:r | r state].
	cs := cs asArray flatten.
	selected := (cs collect: [:c | c selected ]) asArray flatten.
	retour := selected.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/27/2012 16:46'!
launchActionsOnFeatures
	| actions retour rules |
	rules := self configurationStates collect: [:cs | cs rule].
	actions := rules collect: [:r | r actions ].
	actions := actions asArray flatten.
	retour := (actions collect: [:a | a feature ]) asArray flatten.
	^retour! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 12:18'!
numberOfActions
	<MSEProperty: #numberOfActions type: #Number>
	<MSEComment: 'The number of actions that uses me'>
	
	^self
		lookUpPropertyNamed: #numberOfActions
		computedAs: [ self numberOfDeselectedActions + self numberOfSelectedActions ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 12:18'!
numberOfConfigurationDeselectedStates
	<MSEProperty: #numberOfConfigurationDeselectedStates type: #Number>
	<MSEComment: 'The number of configuration state that deselect me'>
	
	^self
		lookUpPropertyNamed: #numberOfConfigurationDeselectedStates
		computedAs: [ self configurationDeselectedStates size ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 12:18'!
numberOfConfigurationSelectedStates
	<MSEProperty: #numberOfConfigurationSelectedStates type: #Number>
	<MSEComment: 'The number of configuration state that select me'>
	
	^self
		lookUpPropertyNamed: #numberOfConfigurationDeselectedStates
		computedAs: [ self configurationSelectedStates size ]! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/26/2012 16:02'!
numberOfConfigurationStates
	<MSEProperty: #numberOfConfigurationStates type: #Number>
	<MSEComment: 'The number of configuration states that uses me'>
	
	^self
		lookUpPropertyNamed: #numberOfConfigurationStates
		computedAs: [ self configurationStates size ]! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:38'!
numberOfDeselectedActions
	^ self deselectedActions size! !

!SPFeature methodsFor: 'metrics' stamp: 'SimonUrli 11/27/2012 16:30'!
numberOfLocalConstraints
	^ self fmFeature numberOfConstraints! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:38'!
numberOfSelectedActions
	^ self selectedActions size! !

!SPFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:37'!
selectedActions
	^ (self mooseModel allWithType: SPActionSelect) select: [ :action | action feature includes: self ]! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:35'!
shortName
	^ shortName! !

!SPFeature methodsFor: 'accessing' stamp: 'SimonUrli 11/23/2012 21:35'!
shortName: anObject
	shortName := anObject! !

!SPFeature methodsFor: 'visualize' stamp: 'SimonUrli 11/26/2012 14:50'!
visualize
	<menuItem: 'Spine Domain Element' category: 'Visualize'> 
	
	| view rawView |
	rawView := ROView new.
	view := ROMondrianViewBuilder view:rawView.
	self visualizeOn: view.
	view open.! !

!SPFeature methodsFor: 'visualize' stamp: 'SimonUrli 11/28/2012 12:30'!
visualizeOn: view
	| centerNode |
	
	centerNode := view node: self forIt:[
		view interaction forward.
		view shape label text: #name.
		view node: self.
	].
	
	view nodes: self isSelectedByFeaturesSelected forEach: [:f |
		| node edge |
		view interaction forward.
		view shape label text: #name.
		node := view node: f.
		edge := ROEdge from: node to: centerNode.
		edge + ((ROLine green) addBegining: ROArrow new).
		view raw add: (edge).
	].

	view shape rectangle fillColor: (Color black).
	view nodes: self isDeselectedByFeaturesDeselected forEach: [:f |
		| node edge |
		view interaction forward.
		view shape label text: #name; color: (Color white).
		node := view node: f.
		edge := ROEdge from: node to: centerNode.
		edge + ((ROLine red) addBegining: ROArrow new).
		view raw add: (edge).
	].

	view flowLayout.! !

SPObject subclass: #SPFeatureModel
	instanceVariableNames: 'fmFeatureModel features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 10:42'!
features
	^ features! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 10:42'!
features: anObject
	features := anObject! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:05'!
fmFeatureModel
	^ fmFeatureModel! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:05'!
fmFeatureModel: anObject
	fmFeatureModel := anObject! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/23/2012 11:08'!
getFeatureNamed: aName
	^ features detect: [ :f | f name = aName ]
	"^ fmFeatureModel featureNamed: aName"! !

!SPFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 11/23/2012 11:02'!
numberOfFeatures
	^ features size ! !

!SPFeatureModel methodsFor: 'resolving dependencies' stamp: 'SimonUrli 11/26/2012 11:09'!
resolve
	| fmFeatures |
	features  := features collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ features allSatisfy: [ :obj | obj isKindOf: SPFeature ] ].
	
	fmFeatures := fmFeatureModel features.
	features do: [ :f | 
		 f fmFeature: (fmFeatures detect: [ :fmFeat | fmFeat name = f shortName ])
		].
	features do: [:f |
		f featureModel: self].
	features do: [:f | 
		f featureChildren: ((self mooseModel entityStorage selectAllWithType: SPFeature) select:[:feat | (feat featureModel == self) & ((f fmFeature subFeatures collect:[:myf | myf name]) includes: (feat shortName))])].

	
"	| collectingVisitor |
	collectingVisitor := CollectingVisitor new.
	fmFeatureModel accept: collectingVisitor.
	self mooseModel addAll: collectingVisitor elements.
"! !

SPObject subclass: #SPMultiplicityElement
	instanceVariableNames: 'lowerBound upperBound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPMultiplicityElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:45'!
lowerBound
	^ lowerBound! !

!SPMultiplicityElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:45'!
lowerBound: anObject
	self assert: [ anObject isInteger ].
	lowerBound := anObject! !

!SPMultiplicityElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:45'!
upperBound
	^ upperBound! !

!SPMultiplicityElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 08:45'!
upperBound: anObject
	self assert: [ anObject isInteger ].
	upperBound := anObject! !

!SPObject methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:04'!
name
	^ name! !

!SPObject methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:04'!
name: aName
	name := aName! !

!SPObject methodsFor: 'printing' stamp: 'AlexandreBergel 11/22/2012 09:38'!
printOn: stream
	super printOn: stream.
	stream nextPut: $<.
	stream nextPutAll: self name.
	stream nextPut: $>.! !

!SPObject methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/23/2012 08:58'!
resolve! !

SPObject subclass: #SPRestrictionFunction
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPRestrictionFunction methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/23/2012 09:13'!
resolve
	rules  := rules collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ rules allSatisfy: [ :obj | obj isKindOf: SPRule ] ].
! !

!SPRestrictionFunction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:11'!
rules
	^ rules! !

!SPRestrictionFunction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:11'!
rules: anObject
	rules := anObject! !

SPObject subclass: #SPRule
	instanceVariableNames: 'actions ruleState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPRule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:00'!
actions
	^ actions! !

!SPRule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:00'!
actions: anObject
	actions := anObject! !

!SPRule methodsFor: 'resolving dependencies' stamp: 'SimonUrli 11/27/2012 10:16'!
resolve
	ruleState  := ruleState collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ ruleState allSatisfy: [ :obj | obj isKindOf: SPConfigurationState ] ].

	ruleState do: [:rs |
		rs rule: self 
	].

	actions  := actions collect: [ :idName | self mooseModel entityNamed: idName ].
	self assert: [ actions allSatisfy: [ :obj | obj isKindOf: SPAbstractAction ] ].

	actions do: [:a |
		a rule: self
	].! !

!SPRule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:47'!
state
	^ ruleState! !

!SPRule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/22/2012 09:47'!
state: anObject
	ruleState := anObject! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 15:44'!
allAssignments
	<navigation: 'All assigment'>
	^ FMAssignmentGroup 
		withAll: (self allWithType: FMAssignment )
		withDescription: 'Assignment'
	! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 01:05'!
allFeatureModels
	<navigation: 'All feature models'>
	^ FMFeatureModelGroup 
		withAll: (self allWithType: FMFeatureModel )
		withDescription: 'Feature models'
	! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 14:29'!
allFeatures
	<navigation: 'All features'>
	^ FMFeatureGroup 
		withAll: (self allWithType: FMFeature )
		withDescription: 'Features'
	! !

!MooseModel methodsFor: '*familiar-spine' stamp: 'SimonUrli 11/23/2012 21:14'!
allSpineDomainElements
	<navigation: 'All Spine domain elements'>
	^ SPDomainElementGroup
		withAll: (self allWithType: SPDomainElement)
		withDescription: 'Spine Domain Element'
	! !

!MooseModel methodsFor: '*familiar-spine' stamp: 'SimonUrli 11/23/2012 21:10'!
allSpineFeatureModels
	<navigation: 'All Spine feature models'>
	^ SPFeatureModelGroup
		withAll: (self allWithType: SPFeatureModel )
		withDescription: 'Spine Feature Model'
	! !

!MooseModel methodsFor: '*familiar-spine' stamp: 'AlexandreBergel 11/23/2012 12:08'!
allSpineFeatures
	<navigation: 'All Spine features'>
	^ SPFeatureGroup 
		withAll: (self allWithType: SPFeature )
		withDescription: 'Spine Features'
	! !

TestCase subclass: #FMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

FMTest subclass: #FMFeatureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 15:10'!
testConstraints1

	| fm c d |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> D ; )'.

	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: (fm constraintsContainingFeature: c) = c constraints.
	self assert: c constraints size = 1.
	
	self assert: (fm constraintsContainingFeature: d) = d constraints.
	self assert: d constraints size = 1.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
testConstraints2

	| fm c d |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C <-> D ; )'.

	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: (fm constraintsContainingFeature: c) = c constraints.
	self assert: c constraints size = 1.
	
	self assert: (fm constraintsContainingFeature: d) = d constraints.
	self assert: d constraints size = 1.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 17:02'!
testConstraints3

	| fm c d a b |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | ( D | !!E) ) ;  (C | A); C & D;)'.

	a := fm featureNamed: 'A'.
	b := fm featureNamed: 'B'.
	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: c numberOfConstraints = 3.
	self assert: d numberOfConstraints = 2.
	self assert: a numberOfConstraints = 1.
	self assert: b numberOfConstraints = 0.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 10:54'!
testConstraints4

	| fm c d a b e cons |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | ( D | !!(E & A) ) ) ; )'.

	a := fm featureNamed: 'A'.
	b := fm featureNamed: 'B'.
	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	e := fm featureNamed: 'E'.
	
	self assert: a constraints size = 1.
	
	cons := a constraints first.
	self assert:  (cons features includesAllOf: {c . e . a . d}).
	self assert:  ({c . e . a . d} includesAllOf: cons features).
	
	self assert: (a constrainedFeatures includesAllOf: {c .d .e}).
	self assert: ({c .d .e} includesAllOf: a constrainedFeatures).
	self assert: (b constrainedFeatures isEmpty).! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 10:59'!
testEquality

	| fm1 fm2 fm3 |
	fm1 := FMFeature new name: 'A'.
	fm2 := FMFeature new name: 'A'.
	fm3 := FMFeature new name: 'AA'.
	self assert: fm1 = fm2.
	self assert: fm1 ~~ fm2.
	
	self assert: fm1 ~= fm3.
	self assert: fm1 ~~ fm3.! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/3/2012 17:13'!
testEquality2

	self deny: FMFeature new = Object new.
	self deny: (FMFeature named: 'foo') = 'foo'.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:26'!
testExclusion1
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> D ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.
	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'D' }.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:38'!
testExclusion2
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> (D | E) ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.

	self assert: (fm featureNamed: 'E') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'E') implying isEmpty.

	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:38'!
testExclusion3
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | Z) -> (D | E) ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'Z' .  fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.

	self assert: (fm featureNamed: 'E') impliedBy = { fm featureNamed: 'Z' .  fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'E') implying isEmpty.

	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.

	self assert: (fm featureNamed: 'Z') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'Z') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:32'!
testExclusion4
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; A -> !! B ; )'.
	
	self deny: (fm featureNamed: 'B') impliedBy = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'B') exclusions = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'A') exclusions = { fm featureNamed: 'B' }! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:12'!
testExclusion5
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ;  !!A -> B ; )'.
	
	self assert: (fm featureNamed: 'B') impliedBy isEmpty.
	self assert: (fm featureNamed: 'B') implying isEmpty.
	
	self assert: (fm featureNamed: 'A') impliedBy isEmpty.
	self assert: (fm featureNamed: 'A') implying isEmpty.
! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:35'!
testExclusion6
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; A -> !! (B | C) ; )'.
	
	self assert: (fm featureNamed: 'A') impliedBy isEmpty.
	self assert: (fm featureNamed: 'B') impliedBy isEmpty.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.

	self assert: (fm featureNamed: 'B') exclusions = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'A') exclusions = { fm featureNamed: 'B' .  fm featureNamed: 'C' }.
	
	self assert: (fm featureNamed: 'B') numberOfExclusions = 1.
	self assert: (fm featureNamed: 'C') numberOfExclusions = 1.
	self assert: (fm featureNamed: 'A') numberOfExclusions = 2.! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 11:00'!
testHash

	| fm1 fm2 fm3 |
	fm1 := FMFeature new name: 'A'.
	fm2 := FMFeature new name: 'A'.
	fm3 := FMFeature new name: 'AA'.
	self assert: fm1 hash = fm2 hash.
	
	self assert: fm1 hash ~= fm3 hash.
	! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:32'!
testMooseName

	| fm |
	fm := FMFeatureModel new.
	self assert: fm mooseName isString! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:35'!
testMooseName2

	| fm str |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B C [D];)'.
	self assert: fm mooseName isString.
	
	str := WriteStream on: String new.
	fm mooseNameOn: str.
	self assert: str contents isString! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/6/2012 17:04'!
testSubFeatureKind

	| fm str |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B (C | D)? [E] (F | G)+ (H | I | J); )'.
	self assert: fm numberOfFeatures = 10.
	
	self assert: (fm featureNamed: 'A') isMandatory.
	self assert: (fm featureNamed: 'B') isMandatory.

	self assert: (fm featureNamed: 'C') isMutex.
	self assert: (fm featureNamed: 'D') isMutex.
	
	self assert: (fm featureNamed: 'E') isOptional.
	
	self assert: (fm featureNamed: 'F') isOr.
	self assert: (fm featureNamed: 'G') isOr.
	
	self assert: (fm featureNamed: 'H') isXor.
	self assert: (fm featureNamed: 'I') isXor.
	self assert: (fm featureNamed: 'J') isXor.
	
	self deny: (fm featureNamed: 'J') isOptional.
	self deny: (fm featureNamed: 'E') isXor.! !

FMTest subclass: #FMImportCommandTest
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMImportCommandTest methodsFor: 'running' stamp: 'AlexandreBergel 7/3/2012 16:18'!
setUp

	command := FMTextImportCommand new.! !

!FMImportCommandTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 16:51'!
testIsParseable
	self assert: (command isParseable: 'foobar = FM (A : B C [D] ;)').
	"self deny: (command isParseable: 'foobar = FM ((A : B C [D] ;)')."! !

!FMImportCommandTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 14:39'!
testParse
	| model |
	model := command modelForTextualDescription: 'foobar = FM (A : B C [D] ;)'.
	self assert: (model class == MooseModel).
	
	self assert: (model allFeatureModels size = 1).
	self assert: (model allAssignments size = 1).
	self assert: (model allFeatures size = 4).
	self assert: (model allFeatures allSatisfy: [ :f | f featureModel notNil ]).
	self assert: (model allFeatureModels allSatisfy: [ :fm | fm features allSatisfy: [ :f | f featureModel == fm ] ] ).
	
	"self assert: (model allVariables) = {'foobar'}"
	! !

FMTest subclass: #FMParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

FMParserTest subclass: #FMASTBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMASTBuilderTest methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 09:30'!
parser
	^ FMASTBuilder new! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:04'!
source1

	^ 'source1 = FM (Source: Product TypeInfo Property;
			  Product: PictureAlbum;
			  PictureAlbum: Picasa;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: Selection [Secured];
			  Selection: (ByTag|ByUrl)+;)
			  
source2 = FM (Source: Product TypeInfo [Property];
			  Product: PictureAlbum;
			  PictureAlbum: Flickr;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: [Secured];)
			  
			  			  
source3 = FM (Source: Product TypeInfo;
			  Product: PictureAlbum;
			  PictureAlbum: PictureDir;
			  TypeInfo: Array;
			  Array: Picture;)
			  
source4 = FM (Source: Product TypeInfo [Property];
			  Product: Twitter;
			  TypeInfo: Array;
			  Array: Tweet;
			  Property: [Secured];)
			  
source5 = FM (Source: Product TypeInfo;
			  Product: NewsFeed;
			  TypeInfo: Array;
			  Array: News;)

			  			  
source6 = FM (Source: Product TypeInfo;
			  Product: Menu;
			  TypeInfo: MenuInfo;)
			  
source7 = FM (Source: Product TypeInfo Property;
			   Product: WeatherBug;
			   TypeInfo: Array;
			   Array: Weather;
			   Property: ForecastDelay;
			   ForecastDelay: (OneDay|ThreeDays|TenDays)+;)
		
source8 = FM (Source: Product TypeInfo;
			  Product: Announcer;
			  TypeInfo: Array;
			  Array: Annonce;)

source9 = FM (Source: Product TypeInfo;
			  Product: Calendar;
			  Calendar: (Agenda | HyperPlanning | GPU);
			  TypeInfo: Array;
			  Array: CalendarEvent;)
			  
source10 = FM (Source: Product TypeInfo;
			   Product: EmergencyManager;
			   TypeInfo: Array;
			   Array: Emergency;)

source11 = FM (Source: Product TypeInfo;
			   Product: ItemListSource;
			   TypeInfo: Array;
			   Array: Item;)			   
source12 = FM (Source: Product TypeInfo;
			   Product: Statistics;
			   TypeInfo: Array;
			   Array: Stat;)	
			    

test1 = FM (Root: Alarm Trigger;
			Trigger: Trigger_Date;)
			
test2 = FM(Racine: Tri Critere;
			Critere: Critere_Date Critere_Poids;)
			  '! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild1
	| c firstChild secondChild thirdChild |
	c := self parser child parse: 'B'.
	self assert: c isCollection.
	self assert: c first class == FMFeatureMendatory.
	self assert: c first feature = (FMFeature named: 'B')
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild2Multiple
	| c firstChild secondChild thirdChild |
	c := self parser children parse: 'B C D'.
	
	self assert: (c class == Array).
	self assert: (c allSatisfy: [ :cc | cc class ==  FMFeatureMendatory ]).
	self assert: c first feature name = 'B'.
	self assert: c second feature name = 'C'.
	self assert: c third  feature name = 'D'.
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild3
	| c thirdChild firstChild secondChild |
	c := self parser children parse: 'B (C | D)+'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class ==  FMFeatureMendatory.
	self assert: firstChild feature name = 'B'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureOr.
	self assert: secondChild feature name = 'C'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureOr.
	self assert: thirdChild feature name = 'D'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild4
	| c thirdChild firstChild secondChild |
	c := self parser children parse: '(C | D)+ B'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class == FMFeatureOr .
	self assert: firstChild feature name = 'C'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureOr.
	self assert: secondChild feature name = 'D'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: thirdChild feature name = 'B'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild5
	| c thirdChild firstChild secondChild |
	c := self parser children parse: '(C | D)? B'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class == FMFeatureMutex .
	self assert: firstChild feature name = 'C'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureMutex.
	self assert: secondChild feature name = 'D'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: thirdChild feature name = 'B'.
	
! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint1
	| c |
	c := self parser constraint parse: 'C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right name = 'A'.
	self assert: c left name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint2
	| c |
	c := self parser constraint parse: 'C -> A'.
	self assert: c class == FMConstraintArrow.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint3
	| c |
	c := self parser constraint parse: 'C <-> A'.
	self assert: c class == FMConstraintEquiv.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint4
	| c |
	c := self parser constraint parse: 'C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/7/2012 13:40'!
testBuildingConstraint5
	| c |
	c := self parser constraint parse: 'C | !!A'.
	self assert: c class == FMConstraintPipe.
	self assert: c left  name = 'C'.
	self assert: c right  class == FMConstraintNegated.
	self assert: c right  expr name = 'A'! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/7/2012 13:57'!
testBuildingConstraint6
	| c |
	c := self parser constraint parse: '!!C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right  name = 'A'.
	self assert: c left  class == FMConstraintNegated.
	self assert: c left  expr name = 'C'! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/2/2012 11:07'!
testBuildingExample1

	| program assigment feature |
	program := self parser program parse: 'renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)'.
					
	self assert: (program class == FMProgram).
	self assert: (program numberOfStatements = 1).

	assigment := program statementAt: 1.
	self assert: (assigment variable = 'renderers11'). 
	
	feature := assigment featureModel.
	self assert: ((feature productionAt: 1) root name = 'Renderer').
	self assert: ((feature productionAt: 1) numberOfChildren = 3).
	
	self assert: (feature numberOfConstraints isZero).
	self assert: (feature numberOfProductions = 6).! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:07'!
testBuildingFeature1
	| c prod |
	c := self parser featureModel parse: 'FM ( A : B ; )'.
	self assert: c class == FMFeatureModel.
	self assert: c numberOfProductions = 1.
	self assert: c numberOfConstraints  isZero.
	
	prod := (c productionAt: 1).
	self assert: prod root name = 'A'.
	self assert: prod numberOfChildren = 1.
	 
	self assert: (prod childAt: 1 ) feature name = 'B' .! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:08'!
testBuildingFeature2
	| c prod |
	c := self parser featureModel parse: 'FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)'.
	self assert: c class == FMFeatureModel.
	self assert: c numberOfProductions = 6.
	self assert: c numberOfConstraints  isZero.
	
	prod := (c productionAt: 1).
	self assert: prod root name =  'Renderer'.
	self assert: prod numberOfChildren = 3.
	 
	prod := (c productionAt: 6).
	self assert: prod root name =  'CalendarRenderer'.
	self assert: prod numberOfChildren = 1.
	self assert: (prod childAt: 1) feature name = 'RenderCalendarDetail'.	! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingNegated
	| c |
	c := self parser constraint parse: '!! A'.
	self assert: c class == FMConstraintNegated.
	self assert: c expr name = 'A'! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction1
	| c firstChild |
	c := self parser production parse: 'A : B'.
	self assert: c class == FMFeatureProduction.
	self assert: c root name = 'A'.
	self assert: c numberOfChildren = 1.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureMendatory.! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction2
	| c firstChild secondChild thirdChild |
	c := self parser production parse: 'A : B C D'.
	self assert: c class == FMFeatureProduction.
	self assert: c root name = 'A'.
	self assert: c numberOfChildren = 3.

	firstChild := c childAt: 1.
	secondChild := c childAt: 2.
	thirdChild := c childAt: 3.
	
	self assert: firstChild feature name = 'B'.
	self assert: secondChild class ==  FMFeatureMendatory.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: secondChild feature name = 'C'.
	self assert: thirdChild feature name  = 'D'.
	! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:48'!
testBuildingProduction3
	| c fourthChild |
	c := self parser production parse: 'A : B C D [E]'.
	self assert: c numberOfChildren = 4.

	fourthChild := c childAt: 4.
	
	self assert: fourthChild class ==  FMFeatureOptional.
	self assert: fourthChild feature name = 'E'.
	
	
	! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 12:36'!
testBuildingProduction4
	| c fourthChild firstChild secondChild |
	c := self parser production parse: 'A : (C | D | E | F) +'.
	self assert: c numberOfChildren = 4.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureOr.
	self assert: firstChild feature name = 'C'.
	
	
	fourthChild := c childAt: 4.
	self assert: fourthChild class ==  FMFeatureOr.
	self assert: fourthChild feature name = 'F'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction5
	| c thirdChild firstChild secondChild |
	c := self parser production parse: 'A : B (C | D)'.
	self assert: c numberOfChildren = 3.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureMendatory.
	self assert: firstChild feature name = 'B'.
	
	secondChild := c childAt: 2.
	self assert: secondChild class ==  FMFeatureXor.
	self assert: secondChild feature name = 'C'.
	
	thirdChild := c childAt: 3.
	self assert: thirdChild class ==  FMFeatureXor.
	self assert: thirdChild feature name = 'D'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 11/23/2012 09:46'!
testFeatureAndFeatureModel

	| featureModel |
	featureModel := self parser featureModel parse: ' FM ( A : B C D; B : E; )'.
	self assert: (featureModel featureNamed: 'A') featureModel == featureModel! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 11/23/2012 09:47'!
testFeatureModelAndNumberOfFeature

	| featureModel v1 v2 |
	featureModel := self parser featureModel parse: ' FM ( A : B C D; B : E; )'.
	v1 := featureModel numberOfFeatures.
	v2 := featureModel numberOfFeatures.
	self assert: v1 = v2! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 11/23/2012 09:50'!
testHierarchy1

	| fm firstFeature |
	fm := self parser featureModel parse: ' FM ( A : B C D; B : E; )'.
	
	self assert: fm numberOfProductions = 2.
	"self assert: fm features = (#('A' 'B' 'C' 'D' 'E') collect: [ :n | FMFeature named: n] )."
	self assert: fm numberOfFeatures = 5.
	
	"self assert: (fm subFeaturesOf: (FMFeature named: 'A')) = (#('B' 'C' 'D') collect: [ :n | FMFeature named: n] )."
	
	firstFeature := fm features first.
	self assert: firstFeature featureModel == fm.
	"self assert: firstFeature subFeatures =  (#('B' 'C' 'D') collect: [ :n | FMFeature named: n] )."! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:03'!
testHierarchy2

	| fm firstFeature |
	fm := self parser featureModel parse: ' FM ( Z : G; A : B ;)'.
	
	self assert: fm numberOfFeatures = 4.

	self assert: (fm featureNamed: 'A') subFeatures first ==   (fm featureNamed: 'B').
	self assert: (fm featureNamed: 'B') == fm features fourth.
	self assert: (fm featureNamed: 'B') subFeatures isEmpty 
! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/1/2012 16:30'!
testProgram
	| program |
	program := FMASTBuilder new program parse: 
'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'.

	self assert: program numberOfStatements = 13.
	self assert: program lastStatement featureModel numberOfProductions = 11.
	self assert: program lastStatement featureModel numberOfConstraints = 52.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/2/2012 12:38'!
testProgram2
	| fm |
	fm := FMASTBuilder new featureModel  parse: 
'FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'.

	self assert: fm notNil.
	self assert: fm numberOfProductions = 11.
	self assert: fm numberOfConstraints = 52.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/3/2012 16:55'!
testProgram3
	| program |
	program := FMASTBuilder new program  parse: 
'printer = FM(Xerox: Category Environmental Products Technology Price Performance Input Finishing Capabilites PrintControllers Security PaperHandling Output ; 
Category: (WideFormatSolutions|Workflowsoftware|DigitalPrintingPresses|ContinuousFeedPrinters|ProductionPrintersandCopiers|BusinessDevelopment) ; 
Environmental: Dimensions ElectricalRequirements ; 
Products: (ColorProducts|MonoProducts) ; 
Technology: ProcessorImaging Memory PDLs CPU PrintEngine_Zero UserInterface Harddisk NetworkInterfaces ; 
Performance: LineScreens RatedSpeed ScanSpeed Resolution Dutycycle Recommendedaveragemonthlyvolume ; 
Input: AutomaticDoucmentFeeder HighCapacityFeeder OtherInputDevices ElectronicInput Tray ; 
Finishing: (SlitterorMerger|Cutting|Finisher|BookletMaking|HolePunch|OtherFinishingOptions|TapeBound|Stacker|Binder|Stapler|ByPassTransport)+ ; 
Capabilites: PrintedSides ProductColor [OptionalCapabilties] PrintLineManagement MICR StandardCapabilities ; 
PrintControllers: Digitalfrontends ; 
Security: (IPfiltering|Imageoverwrite|Secureprint|IPvSixsupport|Authentication|EncryptedScantoemail)+ ; 
PaperHandling: MediaWeightMinimum MediaDimensionsMaximum MediaDimensionsMinimum MediaTypes Maximumpapercapacitywithoptions MediaWeightMaximum Standardpapercapacity Papersources ; 
Output: (OffsetOutputTray|Stacker_Zero|TopTray)+ ; 
WideFormatSolutions: (WideFormatFinishers|ColorWideFormatPrinters|DigitalWideFormatPrintersandCopiers|SoftwareSolutions) ; 
Workflowsoftware: (FreeflowSoftwareandscanners|Productionprintingsoftware|DFEsandcontrollers) ; 
DigitalPrintingPresses: (ColorDigitalPrintingPress|BandWPublishingDigitalPrintingPress|BandWTransactionDigitalPrintingPress|HighLightColorDigitalPrintingPress) ; 
ProductionPrintersandCopiers: (BandWPrinters|ColorPrinters|BandWPublishing|HighLightColor|BandWTransaction) ; 
Dimensions: (Professional|BasicFinisherModuleDC|FeederModuleWithIntegratedScanner|PrintEngine|MultifunctionFinisherProplus|XeroxDSThreeFiveZeroZeroStacker|SheetfeedandInsertionModule|FinishingTransportModule|XeroxTapeBinder|SheetEnhancementModule|BasicFinisherModule|BasicFinisherModulePlus)+ ; 
ColorProducts: (Malta|Chandon|Pinot|Chamonix|Mykonos) ; 
MonoProducts: (Teak|BB|HLC|Nuvera|QM) ; 
ProcessorImaging: (Black|Color)+ ; 
ScanSpeed: (IntegratedScanner|FreeFlowScanner)+ ; 
Resolution: (Scan|Print|Scantofile|RIP|Black_Zero|Color_Zero)+ ; 
HighCapacityFeeder: (StandardFourtraySheet|RollFeedSolution|OversizedHighCapacitySheetFeedModule)+ ; 
OtherInputDevices: (HighCapacityInsertionModule|PostprintFourtrayPaperInsertionModule|InsertionModule|PostprintOversizedTwotrayPaperInsertionModule)+ ; 
Tray: (TrayFive|TrayThree|TrayFour|TrayOne|TrayTwo)+ ; 
Finisher: (MultifunctionFinisherProfessional|BasicFinisherModulePlus_Zero|BasicFinisherModuleDC|BasicFinisherModule_Zero|MultifunctionFinisherProplus_Zero)+ ; 
PrintedSides: [Duplex] ; 
OptionalCapabilties: (Finishing_Zero|Scanning)+ ; 
MICR: (Yes|No) ; 
StandardCapabilities: (Fax|ProductionPrinting|Reprinting|HighvolumenetworkprintingandThreerdpartyfinishing|Copy|Scan_Zero|ProductionMICRPrinting|Print_Zero|Finishing_One)+ ; 
MediaWeightMinimum: (coated_One|uncoated_One)+ ; 
MediaTypes: (speciality|coated|uncoated)+ ; 
MediaWeightMaximum: (uncoated_Zero|coated_Zero)+ ; 
Standardpapercapacity: (SheetFeedModule|HighCapacitySheetFeedModule|StitchingandBindingoption|HighCapacityStackingOption)+ ; 
Papersources: (HighCapacityStackingOption_Zero|HighCapacitySheetFeedModule_Zero|StitchingandBindingoption_Zero|SheetFeedModule_Zero)+ ;)

v = FM ( A : B ; )
'.

	self assert: program notNil.
	self assert: program numberOfStatements = 2.
	self assert: program numberOfVariables = 2.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/3/2012 16:56'!
testProgram4

	| v |
	v := (FMASTBuilder new program parse: 'p = FM (A : B_C ; )') numberOfStatements .
	self assert: v = 1! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:45'!
parseFeatureModel: str
	self assert: (FMParser new featureModel matches: str).
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:48'!
parseProgram: str
	self assert: (FMParser new program matches: str).
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:47'!
parseStatement: str
	self assert: (FMParser new statement matches: str).
	! !

!FMParserTest methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 09:24'!
parser
	^ FMParser new! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:24'!
testConstraint1
	self assert: (self parser constraint matches: 'C | A').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testConstraint2
	self assert: (self parser constraint matches: '!! C | A').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testConstraint3
	self assert: (self parser constraint matches: '(C | A)').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample
	self assert: (self parser featureModel matches: 'FM (A : B C [D]; D : (E|F|G); C : (H|I|J)+ ;  C | I ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample10WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); (RenderAnnonceTitle -> Text);)')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample11WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); (Thumbnails -> !!RenderNewsTitle); )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample2
	self assert: (self parser featureModel matches: 'FM (A : B C [ D ] ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample3
	self assert: (self parser featureModel matches: 'FM ( A : B  ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample4
	self assert: (self parser featureModel matches: 'FM (A : B  C  ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample5
	self assert: (self parser featureModel matches: 'FM (A :  (B  | C); )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample6
	self assert: (self parser featureModel matches: 'FM (A :  (B  | C); A :  (B  | C);  )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample7
	self assert: (self parser featureModel matches: 'FM ( C : (H|I|J) + ;  )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample8WithConstraint
	self assert: (self parser featureModel matches: 'FM (A : B C [D]; D : (E|F|G); C : (H|I|J)+ ;  !! C | I ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testExample9WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); )')! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:47'!
testExamples

	self parseStatement: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)'! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testIdentifier

	self assert: (self parser fmlIdentifier parse: 'HelloWorld') = 'HelloWorld'! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 14:12'!
testIdentifier2

	self assert: (self parser fmlIdentifier parse: 'Hello World') = 'Hello' ! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 10:24'!
testParsing

	| ast |
	ast := self parser program parse: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)'.
					
	! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testProduction
	self assert: (self parser production matches: 'A : B ')! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 09:12'!
testProgram
	self parseProgram: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 09:13'!
testProgram2
	self parseProgram: 'rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'! !

FMTest subclass: #FMVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMVisitorTest methodsFor: 'source' stamp: 'AlexandreBergel 7/2/2012 13:17'!
program1

^ 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)'! !

!FMVisitorTest methodsFor: 'source' stamp: 'AlexandreBergel 7/2/2012 13:19'!
program2

	^ 'source1 = FM (Source: Product TypeInfo Property;
			  Product: PictureAlbum;
			  PictureAlbum: Picasa;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: Selection [Secured];
			  Selection: (ByTag|ByUrl)+;)
			  
source2 = FM (Source: Product TypeInfo [Property];
			  Product: PictureAlbum;
			  PictureAlbum: Flickr;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: [Secured];)
			  
			  			  
source3 = FM (Source: Product TypeInfo;
			  Product: PictureAlbum;
			  PictureAlbum: PictureDir;
			  TypeInfo: Array;
			  Array: Picture;)
			  
source4 = FM (Source: Product TypeInfo [Property];
			  Product: Twitter;
			  TypeInfo: Array;
			  Array: Tweet;
			  Property: [Secured];)
			  
source5 = FM (Source: Product TypeInfo;
			  Product: NewsFeed;
			  TypeInfo: Array;
			  Array: News;)

			  			  
source6 = FM (Source: Product TypeInfo;
			  Product: Menu;
			  TypeInfo: MenuInfo;)
			  
source7 = FM (Source: Product TypeInfo Property;
			   Product: WeatherBug;
			   TypeInfo: Array;
			   Array: Weather;
			   Property: ForecastDelay;
			   ForecastDelay: (OneDay|ThreeDays|TenDays)+;)
		
source8 = FM (Source: Product TypeInfo;
			  Product: Announcer;
			  TypeInfo: Array;
			  Array: Annonce;)

source9 = FM (Source: Product TypeInfo;
			  Product: Calendar;
			  Calendar: (Agenda | HyperPlanning | GPU);
			  TypeInfo: Array;
			  Array: CalendarEvent;)
			  
source10 = FM (Source: Product TypeInfo;
			   Product: EmergencyManager;
			   TypeInfo: Array;
			   Array: Emergency;)

source11 = FM (Source: Product TypeInfo;
			   Product: ItemListSource;
			   TypeInfo: Array;
			   Array: Item;)			   
source12 = FM (Source: Product TypeInfo;
			   Product: Statistics;
			   TypeInfo: Array;
			   Array: Stat;)	
			      

test1 = FM (Root: Alarm Trigger;
			Trigger: Trigger_Date;)
			
test2 = FM(Racine: Tri Critere;
			Critere: Critere_Date Critere_Poids;)
			  '! !

!FMVisitorTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:21'!
testVisitor

	| visitorClasses |
	visitorClasses := FMVisitor withAllSubclasses.
	visitorClasses do: [ :vcls |
		#(#program1 #program2 ) do: [ :k | 
			(FMASTBuilder new program parse: (self perform: k)) accept: vcls new ] ] ! !

TestCase subclass: #SPParserTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Tests'!

!SPParserTest methodsFor: 'running' stamp: 'AlexandreBergel 11/19/2012 12:28'!
setUp
	super setUp.
	parser := SPParser new.! !

!SPParserTest methodsFor: 'action deselect' stamp: 'AlexandreBergel 11/21/2012 17:48'!
testActionDeselect1
	| actionDeselect |
	
	actionDeselect := parser parseActionDeselect: '[ROASSAL] ActionDeselect id="AD_0" feature=[PictureAlbum] fm=[fm_renderer]'.
	
	self assert: actionDeselect name = 'AD_0'.
	self assert: actionDeselect feature = #('PictureAlbum').
	self assert: actionDeselect fm = #('fm_renderer').! !

!SPParserTest methodsFor: 'action select' stamp: 'AlexandreBergel 11/21/2012 17:51'!
testActionSelect1
	| actionDeselect |
	
	actionDeselect := parser parseActionSelect: '[ROASSAL] ActionSelect id="AS_0" feature=[Calendar] fm=[fm_renderer]'.
	
	self assert: actionDeselect name = 'AS_0'.
	self assert: actionDeselect feature = #('Calendar').
	self assert: actionDeselect fm = #('fm_renderer').! !

!SPParserTest methodsFor: 'begin end' stamp: 'AlexandreBergel 11/19/2012 12:27'!
testBeginEnd

	self should: [ parser parse: '' ] raise: Error.
	self should: [ parser parse: '[ROASSAL] BEGIN MODEL' ] raise: Error.
	self should: [ parser parse: '[ROASSAL] END MODEL' ] raise: Error.
	
	self shouldnt: [ parser parse: '[ROASSAL] BEGIN MODEL', String cr, '[ROASSAL] END MODEL' ] raise: Error.
	self shouldnt: [ parser parse: '>> list of FeatureModels', String cr, 
									'[ROASSAL] BEGIN MODEL', String cr, 
									'[ROASSAL] END MODEL' ] raise: Error.! !

!SPParserTest methodsFor: 'configuration state' stamp: 'AlexandreBergel 11/22/2012 08:58'!
testConfigurationState1
	| configurationState |
	
	configurationState := parser parseConfigurationState: '[ROASSAL] ConfigurationState id="cs_Rule_0" fm=[fm_source] selected=[Calendar] deselected=[]'.
	
	self assert: configurationState name = 'cs_Rule_0'.
	self assert: configurationState fm = #('fm_source').
	self assert: configurationState selected = #('Calendar').
	self assert: configurationState deselected = #().! !

!SPParserTest methodsFor: 'configuration state' stamp: 'AlexandreBergel 11/23/2012 11:17'!
testConfigurationState2
	| configurationState |
	
	parser parse: self trace1.
	parser resolve.
	 
	configurationState := parser mooseModel entityNamed: 'cs_Rule_0'.
	
	self assert: configurationState name = 'cs_Rule_0'.
	self assert: configurationState fm = { parser mooseModel entityNamed: 'fm_source' }.
	self assert: configurationState selected = { parser mooseModel entityNamed: 'fm_source.PictureAlbum' }.
	self assert: configurationState deselected = #().
	 ! !

!SPParserTest methodsFor: 'configuration state' stamp: 'AlexandreBergel 11/23/2012 11:24'!
testConfigurationState4
	| config |
	
	parser parse: self trace1.
	parser resolve.
	
	config :=  parser mooseModel entityNamed: 'cs_Rule_1'.
	
	self assert: config selected isEmpty.
	self assert: config deselected size = 1.
	! !

!SPParserTest methodsFor: 'deassociation' stamp: 'AlexandreBergel 11/22/2012 09:05'!
testDomainElement1
	| domainElementAssociation |
	
	domainElementAssociation := parser parseDEAssociation: '[ROASSAL] DEAssociation id="AssoSourceRenderer" source=[DEAEnd_AssoSourceRenderer_source] target=[DEAEnd_AssoSourceRenderer_target] restrictionFunctions=[SourceRendererTypeInfo]'.
	
	self assert: domainElementAssociation name = 'AssoSourceRenderer'.
	self assert: domainElementAssociation source = #('DEAEnd_AssoSourceRenderer_source').
	self assert: domainElementAssociation target = #('DEAEnd_AssoSourceRenderer_target').
	self assert: domainElementAssociation restrictionFunctions = #('SourceRendererTypeInfo').! !

!SPParserTest methodsFor: 'domain element' stamp: 'AlexandreBergel 11/21/2012 17:54'!
testDomainElement2
	| domainElement |
	
	domainElement := parser parseDomainElement: '[ROASSAL] DomainElement id="source" refers_on=[fm_source] MultiplicityElement=[me_DE_source] belongs_to=[AssoSourceRenderer,AssoRendererSource]'.
	
	self assert: domainElement name = 'source'.
	self assert: domainElement belongsTo = #('AssoSourceRenderer' 'AssoRendererSource').
	self assert: domainElement refersOn = #('fm_source').
	self assert: domainElement multiplicityElement = #('me_DE_source').! !

!SPParserTest methodsFor: 'domain element' stamp: 'AlexandreBergel 11/21/2012 17:40'!
testDomainElementEnd1
	| domainElementEnd |
	
	domainElementEnd := parser parseDomainElementEnd: '[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_source" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_source]'.
	
	self assert: domainElementEnd name = 'DEAEnd_AssoSourceRenderer_source'.
	self assert: domainElementEnd applyOn = #('source').
	self assert: domainElementEnd linkMultiplicity = #('me_DEAEnd_AssoSourceRenderer_source').! !

!SPParserTest methodsFor: 'domain element' stamp: 'SimonUrli 11/23/2012 21:43'!
testDomainElementWithAssociatedElement
	| domainElement |
	
	parser parse: self trace1.
	parser resolve.
	
	domainElement := parser mooseModel entityNamed: 'source'.
	
	self assert: domainElement name = 'source'.
	self assert: domainElement associatedDomainElements notEmpty.
	self assert: domainElement associatedDomainElements first == (parser mooseModel entityNamed: 'renderer') .! !

!SPParserTest methodsFor: 'testing utility' stamp: 'AlexandreBergel 11/23/2012 11:32'!
testFailingParsing

	self should: [ parser getListNamed: 'selected' from: '[ROASSAL] ConfigurationState id="cs_Rule_1" fm=[fm_source] selected[] deselected=[fm_source.PictureAlbum]' ] raise: Error! !

!SPParserTest methodsFor: 'features' stamp: 'SimonUrli 11/23/2012 21:34'!
testFeature1
	| feature |
	
	feature := parser parseFeature: '[ROASSAL] Feature id="fm_layout.Picture" name="Picture"'.
	
	self assert: feature name = 'fm_layout.Picture'.
	self assert: feature shortName = 'Picture'.
! !

!SPParserTest methodsFor: 'feature model' stamp: 'AlexandreBergel 11/23/2012 11:03'!
testFeatureModel1
	| featureModel |
	featureModel := parser parseFeatureModel: '[ROASSAL] FeatureModel id="fm_source" features=[fm_source.Period,fm_source.Sort,fm_source.Popularity,fm_source.TimeLine,fm_source.Calendar,fm_source.Criteria,fm_source.Tweets,fm_source.Name,fm_source.Source,fm_source.TypeInfo,fm_source.FlickR,fm_source.Filter,fm_source.PictureAlbum,fm_source.Date,fm_source.HyperCal,fm_source.Picasa,fm_source.ICalReader,fm_source.Album,fm_source.Twitter] familiar="FM(Source: TypeInfo [Criteria] ;  TypeInfo: (Tweets|Calendar|PictureAlbum) ;  Criteria: [Filter] [Sort] ;  Tweets: Twitter ;  Calendar: (ICalReader|HyperCal) ;  PictureAlbum: (FlickR|Picasa) ;  Filter: (TimeLine|Album|Period) ;  Sort: (Popularity|Date|Name) ;  (TimeLine -> Twitter); (Album -> PictureAlbum); ((Popularity & Date) -> (Twitter | PictureAlbum)); (Name -> PictureAlbum); (Period -> Calendar);)"'.
	
	self assert: featureModel class == SPFeatureModel.
	self assert: featureModel name = 'fm_source'.
	
	self assert: featureModel fmFeatureModel notNil.
	self assert: featureModel numberOfFeatures = 19.
	
	self assert: featureModel numberOfFeatures = featureModel fmFeatureModel numberOfFeatures! !

!SPParserTest methodsFor: 'feature model' stamp: 'SimonUrli 11/26/2012 10:17'!
testFeatureModelResolve

	| feature fm |
	parser parse: self trace1.
	
	feature := parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	fm := parser mooseModel entityNamed: 'fm_source'.
	self assert: feature notNil.
	self assert: feature class == SPFeature.
	self assert: feature fmFeature isNil.
	self assert: feature featureModel isNil.
	
	parser resolve.
	self assert: feature fmFeature notNil.
	self assert: feature fmFeature name = 'PictureAlbum'.
	self assert: feature featureModel = fm.! !

!SPParserTest methodsFor: 'feature model' stamp: 'SimonUrli 11/26/2012 11:11'!
testFeatureModelResolveAndFeatureChildren
	| featurePictureAlbum featurePicasa featureFlickR subFeaturesName |
	parser parse: self trace1.
	
	featurePictureAlbum := parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	featurePicasa :=  parser mooseModel entityNamed: 'fm_source.Picasa'.
	featureFlickR :=  parser mooseModel entityNamed: 'fm_source.FlickR'.
	
	self assert: featurePictureAlbum notNil.
	self assert: featurePicasa notNil.
	self assert: featureFlickR notNil.
	self assert: featurePictureAlbum featureChildren isNil.
	self assert: featurePicasa featureChildren isNil.
	self assert: featureFlickR featureChildren isNil.
	
	parser resolve.
	self assert: featurePictureAlbum featureChildren notNil.
	self assert: featurePictureAlbum featureChildren isEmpty not.
	self assert: (featurePictureAlbum featureChildren includes: featurePicasa).
	self assert: (featurePictureAlbum featureChildren includes: featureFlickR).! !

!SPParserTest methodsFor: 'testing utility' stamp: 'AlexandreBergel 11/20/2012 09:52'!
testGetIdFrom

	self assert: (parser getIdFrom: '[ROASSAL] DomainElement id="Source" Multipli') = 'Source'.
	self assert: (parser getIdFrom: '[ROASSAL] RestrictionFunction id="RendererSourceTypeInfo" rules=[TypeInfo3,TypeInfo4]') = 'RendererSourceTypeInfo'.! !

!SPParserTest methodsFor: 'testing utility' stamp: 'AlexandreBergel 11/20/2012 10:09'!
testGetListNamedFrom

	self assert: (parser getListNamed: 'rules' from: '[ROASSAL] RestrictionFunction id="SourceRendererTypeInfo" rules=[TypeInfo1,TypeInfo2]')
					= #('TypeInfo1' 'TypeInfo2').

	self assert: (parser getListNamed: 'restrictionFunctions' from: '[ROASSAL] FMAssociation id="AssociationZoneRenderer" source=FMAEnd(apply_on=[Zone] LinkMultiplicity=ME(1,1)) target=FMAEnd(apply_on=[Renderer] LinkMultiplicity=ME(1,-1)) restrictionFunctions=[ZoneRendererElements]')
					= #('ZoneRendererElements').
					
	self assert: (parser getListNamed: 'belongs_to' from: '[ROASSAL] DomainElement id="Source" MultiplicityElement=ME(1,-1) belongs_to=[AssociationSourceRenderer,AssociationRendererSource] refers_on=[Source]') = #('AssociationSourceRenderer' 'AssociationRendererSource')! !

!SPParserTest methodsFor: 'features' stamp: 'SimonUrli 11/26/2012 17:25'!
testMetricsWithActions
	| configurationState feature |
	
	parser parse: self trace1.
	parser resolve.
	
	feature :=  parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	
	self assert: feature numberOfDeselectedActions = 1.
	self assert: feature deselectedActions asArray = { parser mooseModel entityNamed: 'AD_3' }.

	self assert: feature numberOfSelectedActions = 1.
	self assert: feature selectedActions asArray = { parser mooseModel entityNamed: 'AS_3' }.

	self assert: feature numberOfActions = 2.
	self assert: feature actions asArray = { parser mooseModel entityNamed: 'AD_3'.parser mooseModel entityNamed: 'AS_3' }! !

!SPParserTest methodsFor: 'features' stamp: 'SimonUrli 11/26/2012 17:31'!
testMetricsWithConfigurationState
	| configurationState feature |
	
	parser parse: self trace1.
	parser resolve.
	
	feature :=  parser mooseModel entityNamed: 'fm_source.PictureAlbum'.
	
	self assert: feature numberOfConfigurationSelectedStates = 1.
	self assert: feature configurationSelectedStates asArray = { parser mooseModel entityNamed: 'cs_Rule_0' }.
	
	self assert: feature numberOfConfigurationDeselectedStates = 1.
	self assert: feature configurationDeselectedStates asArray = { parser mooseModel entityNamed: 'cs_Rule_1' }.
	self assert: feature numberOfConfigurationStates = 2.
	self assert: feature configurationStates asArray = {parser mooseModel entityNamed: 'cs_Rule_0'. parser mooseModel entityNamed: 'cs_Rule_1' }.
	self assert: feature launchActionsOnFeatures asArray = {parser mooseModel entityNamed: 'fm_renderer.PictureAlbum'}.
	self assert: feature isLaunchedByFeatures asArray = {parser mooseModel entityNamed: 'fm_renderer.PictureAlbum'}.! !

!SPParserTest methodsFor: 'multiplicity' stamp: 'AlexandreBergel 11/22/2012 08:46'!
testMultiplicity1
	| multiplicity |
	
	multiplicity := parser parseMultiplicityElement: '[ROASSAL] MultiplicityElement id="me_DE_renderer" lowerBound=1 upperBound=-1'.
	
	self assert: multiplicity name = 'me_DE_renderer'.
	self assert: multiplicity lowerBound = 1.
	self assert: multiplicity upperBound = -1! !

!SPParserTest methodsFor: 'parsing' stamp: 'AlexandreBergel 11/23/2012 11:12'!
testParsing

	self assert: parser mooseModel size = 0.
	parser parse: self trace1.
	self assert: parser mooseModel size = 259.
	self assert: (parser mooseModel entities allSatisfy: [ :el | el mooseModel == parser mooseModel ])! !

!SPParserTest methodsFor: 'parsing' stamp: 'SimonUrli 11/23/2012 21:26'!
testResolveDependencies


	| deaEnd source linkMultiplicity listeDE |
	parser parse: self trace1.
	deaEnd := parser mooseModel entityNamed: 'DEAEnd_AssoSourceRenderer_source'.
	source := parser mooseModel entityNamed: 'source'.
	linkMultiplicity := parser mooseModel entityNamed: 'me_DEAEnd_AssoSourceRenderer_source'.
	
	self assert: deaEnd applyOn = #('source').
	self assert: deaEnd linkMultiplicity = #('me_DEAEnd_AssoSourceRenderer_source').
	
	parser resolve.

	self assert: deaEnd applyOn = { source }.
	self assert: deaEnd linkMultiplicity = { linkMultiplicity }! !

!SPParserTest methodsFor: 'parsing' stamp: 'AlexandreBergel 11/23/2012 11:11'!
testResolveDependenciesWithDomainElement

	
	| featureModel feature familiarFeature action |
	parser parse: self trace1.
	featureModel := parser mooseModel entityNamed: 'fm_renderer'.
	self assert: featureModel notNil.

	action := parser mooseModel entityNamed: 'AD_0'.
	self assert: action feature = #('fm_renderer.PictureAlbum').

	"We link everything"
	parser resolve.
	
	familiarFeature := featureModel getFeatureNamed: 'fm_renderer.PictureAlbum'.
	self assert: familiarFeature notNil.
	self assert: familiarFeature class == SPFeature.
	
	self assert: action feature = { familiarFeature }.! !

!SPParserTest methodsFor: 'parsing' stamp: 'AlexandreBergel 11/23/2012 11:09'!
testResolveDependenciesWithDomainElementWithError

	
	| featureModel feature familiarFeature action featureModel1 featureModel2 familiarFeature1 familiarFeature2 |
	parser parse: self trace1.
	featureModel1 := parser mooseModel entityNamed: 'fm_source'.
	featureModel2 := parser mooseModel entityNamed: 'fm_renderer'.

	"We link everything"
	parser resolve.
	
	familiarFeature1 := featureModel1 getFeatureNamed: 'fm_source.PictureAlbum'.
	familiarFeature2 := featureModel2 getFeatureNamed: 'fm_renderer.PictureAlbum'.
	self assert: familiarFeature1 ~~ familiarFeature2.
	"self assert: familiarFeature1 ~= familiarFeature2."
	self assert: familiarFeature1 name = 'fm_source.PictureAlbum'.
	self assert: familiarFeature2 name = 'fm_renderer.PictureAlbum'.
	 
	
	"---"
	action := parser mooseModel entityNamed: 'AD_0'.
	"self assert: action feature ~= { familiarFeature1 }."
	self assert: action feature first = familiarFeature2.
	self assert: action feature = { familiarFeature2 }.! !

!SPParserTest methodsFor: 'restriction function' stamp: 'AlexandreBergel 11/22/2012 09:12'!
testRestrictionFunction
	| restrictionFunction |
	
	restrictionFunction := parser parseRestrictionFunction: '[ROASSAL] RestrictionFunction id="SourceRendererTypeInfo" rules=[Rule_0,Rule_1]'.
	
	self assert: restrictionFunction name = 'SourceRendererTypeInfo'.
	self assert: restrictionFunction rules = #('Rule_0' 'Rule_1').! !

!SPParserTest methodsFor: 'rules' stamp: 'AlexandreBergel 11/22/2012 09:01'!
testRule1
	| rule |
	
	rule := parser parseRule: '[ROASSAL] Rule id="Rule_0" state=[cs_Rule_0] actions=[AS_0,AD_0]'.
	
	self assert: rule name = 'Rule_0'.
	self assert: rule state = #('cs_Rule_0').
	self assert: rule actions = #('AS_0' 'AD_0')! !

!SPParserTest methodsFor: 'rules' stamp: 'SimonUrli 11/26/2012 15:45'!
testRuleResolve
	
	| rule cs action |
	parser parse: self trace1.
	
	rule := parser mooseModel entityNamed: 'Rule_0'.
	cs := parser mooseModel entityNamed: 'cs_Rule_0'.
	action := parser mooseModel entityNamed: 'AS_0'.
	
	self assert: rule notNil.
	self assert: cs notNil.
	self assert: action notNil.
	
	self assert: rule state = {'cs_Rule_0'}.
	self assert: rule actions = {'AS_0'}.
	parser resolve.
	
	self assert: rule state = {cs}.
	self assert: rule actions = {action}.
	self assert: action rule = rule.
	self assert: cs rule = rule.
	! !

!SPParserTest methodsFor: 'begin end' stamp: 'AlexandreBergel 11/19/2012 15:56'!
testTag

	self should: [ parser assertBeginWithTag: '>> list of FeatureModels' ] raise: Error.
	self shouldnt: [ parser assertBeginWithTag: '[ROASSAL] FeatureModel' ] raise: Error! !

!SPParserTest methodsFor: 'example' stamp: 'AlexandreBergel 11/23/2012 11:33'!
trace1

^'[ROASSAL] BEGIN MODEL
>> list of FeatureModel
[ROASSAL] FeatureModel id="fm_source" features=[fm_source.Period,fm_source.Sort,fm_source.Popularity,fm_source.TimeLine,fm_source.Calendar,fm_source.Criteria,fm_source.Tweets,fm_source.Source,fm_source.Name,fm_source.TypeInfo,fm_source.FlickR,fm_source.Filter,fm_source.PictureAlbum,fm_source.HyperCal,fm_source.Date,fm_source.Picasa,fm_source.ICalReader,fm_source.Album,fm_source.Twitter] familiar="FM(Source: TypeInfo [Criteria] ;  TypeInfo: (Tweets|Calendar|PictureAlbum) ;  Criteria: [Filter] [Sort] ;  Tweets: Twitter ;  Calendar: (ICalReader|HyperCal) ;  PictureAlbum: (FlickR|Picasa) ;  Filter: (TimeLine|Album|Period) ;  Sort: (Popularity|Date|Name) ;  (TimeLine -> Twitter); (Album -> PictureAlbum); ((Popularity & Date) -> (Twitter | PictureAlbum)); (Name -> PictureAlbum); (Period -> Calendar);)"
[ROASSAL] FeatureModel id="fm_devices" features=[fm_devices.Resolution,fm_devices.Product,fm_devices.Monitor,fm_devices.R1280x1024,fm_devices.Devices,fm_devices.M12F913,fm_devices.R1920x1080,fm_devices.X2427HD,fm_devices.R1600x900,fm_devices.TV,fm_devices.R1440x900] familiar="FM(Devices: Resolution Product ;  Resolution: (R1600x900|R1920x1080|R1280x1024|R1440x900) ;  Product: (Monitor|TV) ;  Monitor: X2427HD ;  TV: M12F913 ;  (X2427HD <-> (R1600x900 | R1920x1080)); (M12F913 <-> (R1280x1024 | R1440x900));)"
[ROASSAL] FeatureModel id="fm_renderer" features=[fm_renderer.Picture,fm_renderer.FullTweet,fm_renderer.Mosaic,fm_renderer.Week,fm_renderer.Format,fm_renderer.Slide,fm_renderer.Logo,fm_renderer.ContentOnly,fm_renderer.Calendar,fm_renderer.Day,fm_renderer.Tweets,fm_renderer.Month,fm_renderer.Title,fm_renderer.Cadre,fm_renderer.TypeInfo,fm_renderer.Text,fm_renderer.Renderer,fm_renderer.PictureAlbum,fm_renderer.Ligne,fm_renderer.Content] familiar="FM(Renderer: TypeInfo Format ;  TypeInfo: (Tweets|Calendar|PictureAlbum) ;  Format: (Cadre|Ligne) ;  Tweets: (ContentOnly|FullTweet) ;  Calendar: (Day|Week|Month) ;  PictureAlbum: (Mosaic|Slide) ;  Cadre: [Title] [Picture] Text ;  Ligne: Content [Logo] ;  (Logo <-> ContentOnly); (Calendar -> ((Cadre & Title) | (Ligne & !!Logo))); (Cadre -> ((FullTweet | Calendar) | PictureAlbum)); (ContentOnly -> (Ligne & Logo)); (Title <-> Calendar); (Ligne -> (ContentOnly | Calendar)); (FullTweet -> (Cadre & Picture)); (Picture -> (PictureAlbum | FullTweet)); (PictureAlbum -> (Cadre & Picture));)"
[ROASSAL] FeatureModel id="fm_layout" features=[fm_layout.Picture,fm_layout.IRSAM,fm_layout.Format,fm_layout.Resolution,fm_layout.Logo,fm_layout.CA,fm_layout.R1600x900,fm_layout.Title,fm_layout.Two,fm_layout.R1440x900,fm_layout.Cadre,fm_layout.EPU,fm_layout.Text,fm_layout.N2I,fm_layout.Layout,fm_layout.R1280x1024,fm_layout.Ligne,fm_layout.Zone,fm_layout.R1920x1080,fm_layout.One,fm_layout.Content] familiar="FM(Layout: Resolution Zone Format ;  Resolution: (R1600x900|R1920x1080|R1280x1024|R1440x900) ;  Zone: (Two|One) ;  Format: (Cadre|Ligne)+ ;  Two: (EPU|N2I) ;  One: (CA|IRSAM) ;  Cadre: [Title] [Picture] Text ;  Ligne: Content [Logo] ;  (EPU -> ((R1600x900 | R1920x1080) & ((Logo & Picture) & Title))); (R1920x1080 -> (N2I | EPU)); (Title -> EPU); (CA -> (((R1280x1024 & Cadre) & Picture) & !!Ligne)); (IRSAM -> ((R1440x900 & Cadre) & !!Ligne)); (!!Ligne -> (IRSAM | CA)); (N2I -> ((R1920x1080 & Picture) & Logo)); (Picture -> ((N2I | EPU) | CA));)"
>> list of DEAEnd
[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_source" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererSource_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererSource_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererSource_target" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoRendererSource_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererLayout_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererLayout_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererLayout_target" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoRendererLayout_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutRenderer_source" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoLayoutRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoLayoutRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererDevices_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererDevices_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererDevices_target" apply_on=[devices] linkMultiplicity=[me_DEAEnd_AssoRendererDevices_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoDevicesRenderer_source" apply_on=[devices] linkMultiplicity=[me_DEAEnd_AssoDevicesRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoDevicesRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoDevicesRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutDevices_source" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoLayoutDevices_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutDevices_target" apply_on=[devices] linkMultiplicity=[me_DEAEnd_AssoLayoutDevices_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoDevicesLayout_source" apply_on=[devices] linkMultiplicity=[me_DEAEnd_AssoDevicesLayout_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoDevicesLayout_target" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoDevicesLayout_target]
>> list of ActionDeselect
[ROASSAL] ActionDeselect id="AD_0" feature=[fm_renderer.PictureAlbum] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_1" feature=[fm_renderer.Calendar] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_2" feature=[fm_renderer.Tweets] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_3" feature=[fm_source.PictureAlbum] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_4" feature=[fm_source.Calendar] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_5" feature=[fm_source.Tweets] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_6" feature=[fm_source.HyperCal] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_8" feature=[fm_renderer.Cadre] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_7" feature=[fm_renderer.Ligne] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_9" feature=[fm_renderer.Logo] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_10" feature=[fm_renderer.Picture] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_11" feature=[fm_renderer.Title] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_12" feature=[fm_renderer.Mosaic] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_13" feature=[fm_devices.R1280x1024] fm=[fm_devices]
[ROASSAL] ActionDeselect id="AD_14" feature=[fm_devices.R1600x900] fm=[fm_devices]
[ROASSAL] ActionDeselect id="AD_15" feature=[fm_devices.R1440x900] fm=[fm_devices]
[ROASSAL] ActionDeselect id="AD_16" feature=[fm_devices.R1920x1080] fm=[fm_devices]
[ROASSAL] ActionDeselect id="AD_17" feature=[fm_layout.R1280x1024] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_18" feature=[fm_layout.R1600x900] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_19" feature=[fm_layout.R1440x900] fm=[fm_layout]
[ROASSAL] ActionDeselect id="AD_20" feature=[fm_layout.R1920x1080] fm=[fm_layout]
>> list of ActionSelect
[ROASSAL] ActionSelect id="AS_0" feature=[fm_renderer.PictureAlbum] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_1" feature=[fm_renderer.Calendar] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_2" feature=[fm_renderer.Tweets] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_6" feature=[fm_renderer.Day] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_3" feature=[fm_source.PictureAlbum] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_4" feature=[fm_source.Calendar] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_5" feature=[fm_source.Tweets] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_8" feature=[fm_layout.Cadre] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_7" feature=[fm_layout.Ligne] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_9" feature=[fm_layout.Logo] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_10" feature=[fm_layout.Picture] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_11" feature=[fm_layout.Title] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_12" feature=[fm_devices.R1920x1080] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_13" feature=[fm_devices.R1280x1024] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_14" feature=[fm_devices.R1600x900] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_15" feature=[fm_devices.R1440x900] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_16" feature=[fm_devices.R1920x1080] fm=[fm_devices]
[ROASSAL] ActionSelect id="AS_17" feature=[fm_layout.R1280x1024] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_18" feature=[fm_layout.R1600x900] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_19" feature=[fm_layout.R1440x900] fm=[fm_layout]
[ROASSAL] ActionSelect id="AS_20" feature=[fm_layout.R1920x1080] fm=[fm_layout]
>> list of DomainElement
[ROASSAL] DomainElement id="source" refers_on=[fm_source] MultiplicityElement=[me_DE_source] belongs_to=[AssoSourceRenderer,AssoRendererSource]
[ROASSAL] DomainElement id="devices" refers_on=[fm_devices] MultiplicityElement=[me_DE_devices] belongs_to=[AssoRendererDevices,AssoDevicesRenderer,AssoLayoutDevices,AssoDevicesLayout]
[ROASSAL] DomainElement id="renderer" refers_on=[fm_renderer] MultiplicityElement=[me_DE_renderer] belongs_to=[AssoSourceRenderer,AssoRendererSource,AssoRendererLayout,AssoLayoutRenderer,AssoRendererDevices,AssoDevicesRenderer]
[ROASSAL] DomainElement id="layout" refers_on=[fm_layout] MultiplicityElement=[me_DE_layout] belongs_to=[AssoDevicesLayout,AssoLayoutDevices,AssoLayoutRenderer,AssoRendererLayout]
>> list of MultiplicityElement
[ROASSAL] MultiplicityElement id="me_DE_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DE_devices" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DE_renderer" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DE_layout" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoSourceRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoSourceRenderer_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererSource_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererSource_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererLayout_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererLayout_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutRenderer_target" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererDevices_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererDevices_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoDevicesRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoDevicesRenderer_target" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutDevices_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutDevices_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoDevicesLayout_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoDevicesLayout_target" lowerBound=1 upperBound=1
>> list of ConfigurationState
[ROASSAL] ConfigurationState id="cs_Rule_0" fm=[fm_source] selected=[fm_source.PictureAlbum] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_2" fm=[fm_source] selected=[fm_source.Calendar] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_4" fm=[fm_source] selected=[fm_source.Tweets] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_1" fm=[fm_source] selected=[] deselected=[fm_source.PictureAlbum]
[ROASSAL] ConfigurationState id="cs_Rule_3" fm=[fm_source] selected=[] deselected=[fm_source.Calendar]
[ROASSAL] ConfigurationState id="cs_Rule_5" fm=[fm_source] selected=[] deselected=[fm_source.Tweets]
[ROASSAL] ConfigurationState id="cs_Rule_12" fm=[fm_source] selected=[fm_source.HyperCal] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_6" fm=[fm_renderer] selected=[fm_renderer.PictureAlbum] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_8" fm=[fm_renderer] selected=[fm_renderer.Calendar] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_10" fm=[fm_renderer] selected=[fm_renderer.Tweets] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_7" fm=[fm_renderer] selected=[] deselected=[fm_renderer.PictureAlbum]
[ROASSAL] ConfigurationState id="cs_Rule_9" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Calendar]
[ROASSAL] ConfigurationState id="cs_Rule_11" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Tweets]
[ROASSAL] ConfigurationState id="cs_Rule_13" fm=[fm_renderer] selected=[] deselected=[fm_renderer.Day]
[ROASSAL] ConfigurationState id="cs_Rule_15" fm=[fm_renderer] selected=[fm_renderer.Cadre] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_14" fm=[fm_renderer] selected=[fm_renderer.Ligne] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_16" fm=[fm_renderer] selected=[fm_renderer.Logo] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_17" fm=[fm_renderer] selected=[fm_renderer.Picture] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_18" fm=[fm_renderer] selected=[fm_renderer.Title] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_20" fm=[fm_layout] selected=[] deselected=[fm_layout.Cadre]
[ROASSAL] ConfigurationState id="cs_Rule_19" fm=[fm_layout] selected=[] deselected=[fm_layout.Ligne]
[ROASSAL] ConfigurationState id="cs_Rule_21" fm=[fm_layout] selected=[] deselected=[fm_layout.Logo]
[ROASSAL] ConfigurationState id="cs_Rule_22" fm=[fm_layout] selected=[] deselected=[fm_layout.Picture]
[ROASSAL] ConfigurationState id="cs_Rule_23" fm=[fm_layout] selected=[] deselected=[fm_layout.Title]
[ROASSAL] ConfigurationState id="cs_Rule_24" fm=[fm_renderer] selected=[fm_renderer.Mosaic] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_25" fm=[fm_devices] selected=[] deselected=[fm_devices.R1920x1080]
[ROASSAL] ConfigurationState id="cs_Rule_26" fm=[fm_layout] selected=[fm_layout.R1280x1024] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_28" fm=[fm_layout] selected=[fm_layout.R1600x900] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_30" fm=[fm_layout] selected=[fm_layout.R1440x900] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_32" fm=[fm_layout] selected=[fm_layout.R1920x1080] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_27" fm=[fm_layout] selected=[] deselected=[fm_layout.R1280x1024]
[ROASSAL] ConfigurationState id="cs_Rule_29" fm=[fm_layout] selected=[] deselected=[fm_layout.R1600x900]
[ROASSAL] ConfigurationState id="cs_Rule_31" fm=[fm_layout] selected=[] deselected=[fm_layout.R1440x900]
[ROASSAL] ConfigurationState id="cs_Rule_33" fm=[fm_layout] selected=[] deselected=[fm_layout.R1920x1080]
[ROASSAL] ConfigurationState id="cs_Rule_34" fm=[fm_devices] selected=[fm_devices.R1280x1024] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_36" fm=[fm_devices] selected=[fm_devices.R1600x900] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_38" fm=[fm_devices] selected=[fm_devices.R1440x900] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_40" fm=[fm_devices] selected=[fm_devices.R1920x1080] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_35" fm=[fm_devices] selected=[] deselected=[fm_devices.R1280x1024]
[ROASSAL] ConfigurationState id="cs_Rule_37" fm=[fm_devices] selected=[] deselected=[fm_devices.R1600x900]
[ROASSAL] ConfigurationState id="cs_Rule_39" fm=[fm_devices] selected=[] deselected=[fm_devices.R1440x900]
[ROASSAL] ConfigurationState id="cs_Rule_41" fm=[fm_devices] selected=[] deselected=[fm_devices.R1920x1080]
>> list of Rule
[ROASSAL] Rule id="Rule_0" state=[cs_Rule_0] actions=[AS_0]
[ROASSAL] Rule id="Rule_2" state=[cs_Rule_2] actions=[AS_1]
[ROASSAL] Rule id="Rule_4" state=[cs_Rule_4] actions=[AS_2]
[ROASSAL] Rule id="Rule_1" state=[cs_Rule_1] actions=[AD_0]
[ROASSAL] Rule id="Rule_3" state=[cs_Rule_3] actions=[AD_1]
[ROASSAL] Rule id="Rule_5" state=[cs_Rule_5] actions=[AD_2]
[ROASSAL] Rule id="Rule_12" state=[cs_Rule_12] actions=[AS_6]
[ROASSAL] Rule id="Rule_6" state=[cs_Rule_6] actions=[AS_3]
[ROASSAL] Rule id="Rule_8" state=[cs_Rule_8] actions=[AS_4]
[ROASSAL] Rule id="Rule_10" state=[cs_Rule_10] actions=[AS_5]
[ROASSAL] Rule id="Rule_7" state=[cs_Rule_7] actions=[AD_3]
[ROASSAL] Rule id="Rule_9" state=[cs_Rule_9] actions=[AD_4]
[ROASSAL] Rule id="Rule_11" state=[cs_Rule_11] actions=[AD_5]
[ROASSAL] Rule id="Rule_13" state=[cs_Rule_13] actions=[AD_6]
[ROASSAL] Rule id="Rule_15" state=[cs_Rule_15] actions=[AS_8]
[ROASSAL] Rule id="Rule_14" state=[cs_Rule_14] actions=[AS_7]
[ROASSAL] Rule id="Rule_16" state=[cs_Rule_16] actions=[AS_9]
[ROASSAL] Rule id="Rule_17" state=[cs_Rule_17] actions=[AS_10]
[ROASSAL] Rule id="Rule_18" state=[cs_Rule_18] actions=[AS_11]
[ROASSAL] Rule id="Rule_20" state=[cs_Rule_20] actions=[AD_8]
[ROASSAL] Rule id="Rule_19" state=[cs_Rule_19] actions=[AD_7]
[ROASSAL] Rule id="Rule_21" state=[cs_Rule_21] actions=[AD_9]
[ROASSAL] Rule id="Rule_22" state=[cs_Rule_22] actions=[AD_10]
[ROASSAL] Rule id="Rule_23" state=[cs_Rule_23] actions=[AD_11]
[ROASSAL] Rule id="Rule_24" state=[cs_Rule_24] actions=[AS_12]
[ROASSAL] Rule id="Rule_25" state=[cs_Rule_25] actions=[AD_12]
[ROASSAL] Rule id="Rule_26" state=[cs_Rule_26] actions=[AS_13]
[ROASSAL] Rule id="Rule_28" state=[cs_Rule_28] actions=[AS_14]
[ROASSAL] Rule id="Rule_30" state=[cs_Rule_30] actions=[AS_15]
[ROASSAL] Rule id="Rule_32" state=[cs_Rule_32] actions=[AS_16]
[ROASSAL] Rule id="Rule_27" state=[cs_Rule_27] actions=[AD_13]
[ROASSAL] Rule id="Rule_29" state=[cs_Rule_29] actions=[AD_14]
[ROASSAL] Rule id="Rule_31" state=[cs_Rule_31] actions=[AD_15]
[ROASSAL] Rule id="Rule_33" state=[cs_Rule_33] actions=[AD_16]
[ROASSAL] Rule id="Rule_34" state=[cs_Rule_34] actions=[AS_17]
[ROASSAL] Rule id="Rule_36" state=[cs_Rule_36] actions=[AS_18]
[ROASSAL] Rule id="Rule_38" state=[cs_Rule_38] actions=[AS_19]
[ROASSAL] Rule id="Rule_40" state=[cs_Rule_40] actions=[AS_20]
[ROASSAL] Rule id="Rule_35" state=[cs_Rule_35] actions=[AD_17]
[ROASSAL] Rule id="Rule_37" state=[cs_Rule_37] actions=[AD_18]
[ROASSAL] Rule id="Rule_39" state=[cs_Rule_39] actions=[AD_19]
[ROASSAL] Rule id="Rule_41" state=[cs_Rule_41] actions=[AD_20]
>> list of DEAssociation
[ROASSAL] DEAssociation id="AssoSourceRenderer" source=[DEAEnd_AssoSourceRenderer_source] target=[DEAEnd_AssoSourceRenderer_target] restrictionFunctions=[SourceRendererTypeInfo,SourceRendererSpecifService]
[ROASSAL] DEAssociation id="AssoRendererSource" source=[DEAEnd_AssoRendererSource_source] target=[DEAEnd_AssoRendererSource_target] restrictionFunctions=[RendererSourceTypeInfo,RendererSourceSpecifRenderer]
[ROASSAL] DEAssociation id="AssoRendererLayout" source=[DEAEnd_AssoRendererLayout_source] target=[DEAEnd_AssoRendererLayout_target] restrictionFunctions=[FormatRendererFormatLayout]
[ROASSAL] DEAssociation id="AssoLayoutRenderer" source=[DEAEnd_AssoLayoutRenderer_source] target=[DEAEnd_AssoLayoutRenderer_target] restrictionFunctions=[FormatLayoutFormatRenderer]
[ROASSAL] DEAssociation id="AssoRendererDevices" source=[DEAEnd_AssoRendererDevices_source] target=[DEAEnd_AssoRendererDevices_target] restrictionFunctions=[SpecifRendererResoDevices]
[ROASSAL] DEAssociation id="AssoDevicesRenderer" source=[DEAEnd_AssoDevicesRenderer_source] target=[DEAEnd_AssoDevicesRenderer_target] restrictionFunctions=[NonResoDevicesNonSpecifRenderer]
[ROASSAL] DEAssociation id="AssoLayoutDevices" source=[DEAEnd_AssoLayoutDevices_source] target=[DEAEnd_AssoLayoutDevices_target] restrictionFunctions=[LayoutDevicesResolution]
[ROASSAL] DEAssociation id="AssoDevicesLayout" source=[DEAEnd_AssoDevicesLayout_source] target=[DEAEnd_AssoDevicesLayout_target] restrictionFunctions=[DevicesLayoutResolution]
>> list of RestrictionFunction
[ROASSAL] RestrictionFunction id="SourceRendererTypeInfo" rules=[Rule_0,Rule_2,Rule_4,Rule_1,Rule_3,Rule_5]
[ROASSAL] RestrictionFunction id="SourceRendererSpecifService" rules=[Rule_12]
[ROASSAL] RestrictionFunction id="RendererSourceTypeInfo" rules=[Rule_6,Rule_8,Rule_10,Rule_7,Rule_9,Rule_11]
[ROASSAL] RestrictionFunction id="RendererSourceSpecifRenderer" rules=[Rule_13]
[ROASSAL] RestrictionFunction id="FormatRendererFormatLayout" rules=[Rule_15,Rule_14,Rule_16,Rule_17,Rule_18]
[ROASSAL] RestrictionFunction id="FormatLayoutFormatRenderer" rules=[Rule_20,Rule_19,Rule_21,Rule_22,Rule_23]
[ROASSAL] RestrictionFunction id="SpecifRendererResoDevices" rules=[Rule_24]
[ROASSAL] RestrictionFunction id="NonResoDevicesNonSpecifRenderer" rules=[Rule_25]
[ROASSAL] RestrictionFunction id="LayoutDevicesResolution" rules=[Rule_26,Rule_28,Rule_30,Rule_32,Rule_27,Rule_29,Rule_31,Rule_33]
[ROASSAL] RestrictionFunction id="DevicesLayoutResolution" rules=[Rule_34,Rule_36,Rule_38,Rule_40,Rule_35,Rule_37,Rule_39,Rule_41]
>> list of Feature
[ROASSAL] Feature id="fm_source.Period" name="Period"
[ROASSAL] Feature id="fm_source.Sort" name="Sort"
[ROASSAL] Feature id="fm_source.Popularity" name="Popularity"
[ROASSAL] Feature id="fm_source.TimeLine" name="TimeLine"
[ROASSAL] Feature id="fm_source.Calendar" name="Calendar"
[ROASSAL] Feature id="fm_source.Criteria" name="Criteria"
[ROASSAL] Feature id="fm_source.Tweets" name="Tweets"
[ROASSAL] Feature id="fm_source.Source" name="Source"
[ROASSAL] Feature id="fm_source.Name" name="Name"
[ROASSAL] Feature id="fm_source.TypeInfo" name="TypeInfo"
[ROASSAL] Feature id="fm_source.FlickR" name="FlickR"
[ROASSAL] Feature id="fm_source.Filter" name="Filter"
[ROASSAL] Feature id="fm_source.PictureAlbum" name="PictureAlbum"
[ROASSAL] Feature id="fm_source.HyperCal" name="HyperCal"
[ROASSAL] Feature id="fm_source.Date" name="Date"
[ROASSAL] Feature id="fm_source.Picasa" name="Picasa"
[ROASSAL] Feature id="fm_source.ICalReader" name="ICalReader"
[ROASSAL] Feature id="fm_source.Album" name="Album"
[ROASSAL] Feature id="fm_source.Twitter" name="Twitter"
[ROASSAL] Feature id="fm_devices.Resolution" name="Resolution"
[ROASSAL] Feature id="fm_devices.Product" name="Product"
[ROASSAL] Feature id="fm_devices.Monitor" name="Monitor"
[ROASSAL] Feature id="fm_devices.R1280x1024" name="R1280x1024"
[ROASSAL] Feature id="fm_devices.Devices" name="Devices"
[ROASSAL] Feature id="fm_devices.M12F913" name="M12F913"
[ROASSAL] Feature id="fm_devices.R1920x1080" name="R1920x1080"
[ROASSAL] Feature id="fm_devices.X2427HD" name="X2427HD"
[ROASSAL] Feature id="fm_devices.R1600x900" name="R1600x900"
[ROASSAL] Feature id="fm_devices.TV" name="TV"
[ROASSAL] Feature id="fm_devices.R1440x900" name="R1440x900"
[ROASSAL] Feature id="fm_renderer.Picture" name="Picture"
[ROASSAL] Feature id="fm_renderer.FullTweet" name="FullTweet"
[ROASSAL] Feature id="fm_renderer.Mosaic" name="Mosaic"
[ROASSAL] Feature id="fm_renderer.Week" name="Week"
[ROASSAL] Feature id="fm_renderer.Format" name="Format"
[ROASSAL] Feature id="fm_renderer.Slide" name="Slide"
[ROASSAL] Feature id="fm_renderer.Logo" name="Logo"
[ROASSAL] Feature id="fm_renderer.ContentOnly" name="ContentOnly"
[ROASSAL] Feature id="fm_renderer.Calendar" name="Calendar"
[ROASSAL] Feature id="fm_renderer.Day" name="Day"
[ROASSAL] Feature id="fm_renderer.Tweets" name="Tweets"
[ROASSAL] Feature id="fm_renderer.Month" name="Month"
[ROASSAL] Feature id="fm_renderer.Title" name="Title"
[ROASSAL] Feature id="fm_renderer.Cadre" name="Cadre"
[ROASSAL] Feature id="fm_renderer.TypeInfo" name="TypeInfo"
[ROASSAL] Feature id="fm_renderer.Text" name="Text"
[ROASSAL] Feature id="fm_renderer.Renderer" name="Renderer"
[ROASSAL] Feature id="fm_renderer.PictureAlbum" name="PictureAlbum"
[ROASSAL] Feature id="fm_renderer.Ligne" name="Ligne"
[ROASSAL] Feature id="fm_renderer.Content" name="Content"
[ROASSAL] Feature id="fm_layout.Picture" name="Picture"
[ROASSAL] Feature id="fm_layout.IRSAM" name="IRSAM"
[ROASSAL] Feature id="fm_layout.Format" name="Format"
[ROASSAL] Feature id="fm_layout.Resolution" name="Resolution"
[ROASSAL] Feature id="fm_layout.Logo" name="Logo"
[ROASSAL] Feature id="fm_layout.CA" name="CA"
[ROASSAL] Feature id="fm_layout.R1600x900" name="R1600x900"
[ROASSAL] Feature id="fm_layout.Title" name="Title"
[ROASSAL] Feature id="fm_layout.Two" name="Two"
[ROASSAL] Feature id="fm_layout.R1440x900" name="R1440x900"
[ROASSAL] Feature id="fm_layout.Cadre" name="Cadre"
[ROASSAL] Feature id="fm_layout.EPU" name="EPU"
[ROASSAL] Feature id="fm_layout.Text" name="Text"
[ROASSAL] Feature id="fm_layout.N2I" name="N2I"
[ROASSAL] Feature id="fm_layout.Layout" name="Layout"
[ROASSAL] Feature id="fm_layout.R1280x1024" name="R1280x1024"
[ROASSAL] Feature id="fm_layout.Ligne" name="Ligne"
[ROASSAL] Feature id="fm_layout.Zone" name="Zone"
[ROASSAL] Feature id="fm_layout.R1920x1080" name="R1920x1080"
[ROASSAL] Feature id="fm_layout.One" name="One"
[ROASSAL] Feature id="fm_layout.Content" name="Content"
[ROASSAL] END MODEL'! !

MPImportCommand subclass: #FMTextImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:33'!
chooseDirectory
	"Let the user pick a folder. Load in Moose all the fml file contained in the folder"
	| dir file |
	dir := UIManager default chooseDirectory.
	dir ifNil: [ ^ self ].

	(dir fileNamesMatching: '*.fml') do: [ :fileName |
		self processFileNamed: (dir fullNameFor: fileName) ].
	
! !

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:35'!
chooseFile
	| fileName file |
	fileName := UIManager default chooseFullFileNameMatching: #('*.fml').
	(fileName isNil or: [ fileName isEmpty ]) ifTrue: [ ^ self ].
	self self processFileNamed: fileName ! !

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:12'!
enterTextualDescription
	| str |
	str := UIManager default 
			multiLineRequest: 'Enter a program' initialAnswer: 'enter your Familiar program' answerHeight: 250.
	self processText: str ! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/6/2012 11:28'!
execute
	| str sel fileName file |
	sel := UIManager default 
			chooseFrom:  #('choose file' 'choose folder' 'enter textual description') 
			values: #(#chooseFile #chooseDirectory #enterTextualDescription).
	sel ifNil: [ ^ self ].
	
	self perform: sel
	! !

!FMTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 7/1/2012 16:48'!
isParseable: string
	^ FMASTBuilder new program matches: string! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/6/2012 11:27'!
label
	^ 'Import Familiar description'! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/2/2012 00:13'!
modelForTextualDescription: string
	"parse string and fill up a moose model. string has to correspond to a program"
	
	| model program collectingVisitor |
	
	"Make sure that the code is parseable"
	self assert: [ self isParseable: string ] description: 'Entered code is not parseable. Please check'.
	model := MooseModel new.
	
	program := FMASTBuilder new program parse: string.
	collectingVisitor := CollectingVisitor new.
	program accept: collectingVisitor.
	model addAll: collectingVisitor elements.
	
	^ model
	! !

!FMTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 7/6/2012 11:27'!
processFileNamed: fileName
	| file |
	[file := FileStream fileNamed: fileName.
	self processText: file contents titled: file localName ]
		on: Error do: [ :ex | 
			UIManager default inform: ex printString.
			file ifNotNil: [ file close ] ] ! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/3/2012 16:54'!
processText: str
	self processText: str titled: 'no name'! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/3/2012 16:53'!
processText: str titled: title
	(str notNil and: [ str notEmpty ])
			ifTrue: [ MooseModel root add: ((self modelForTextualDescription: str) name: title) ]! !

MPImportCommand subclass: #SPTextImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Moose'!

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 11/23/2012 11:53'!
chooseDirectory
	"Let the user pick a folder. Load in Moose all the fml file contained in the folder"
	| dir file |
	dir := UIManager default chooseDirectory.
	dir ifNil: [ ^ self ].

	(dir fileNamesMatching: '*.fml') do: [ :fileName |
		self processFileNamed: (dir fullNameFor: fileName) ].
	
! !

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 11/23/2012 11:55'!
chooseFile
	| fileName file |
	fileName := UIManager default chooseFullFileNameMatching: #('*.fml').
	(fileName isNil or: [ fileName isEmpty ]) ifTrue: [ ^ self ].
	self processFileNamed: fileName ! !

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 11/23/2012 11:53'!
enterTextualDescription
	| str |
	str := UIManager default 
			multiLineRequest: 'Enter a program' initialAnswer: 'enter your Familiar program' answerHeight: 250.
	self processText: str ! !

!SPTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 11/23/2012 12:12'!
example1
	self processText: SPParserTest new trace1 titled: 'Example 1'! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 12:11'!
execute
	| str sel fileName file |
	sel := UIManager default 
			chooseFrom:  #('choose file' 'choose folder' 'enter textual description' 'example 1') 
			values: #(#chooseFile #chooseDirectory #enterTextualDescription #example1).
	sel ifNil: [ ^ self ].
	
	self perform: sel
	! !

!SPTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 11:53'!
isParseable: string
	^ FMASTBuilder new program matches: string! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 11:53'!
label
	^ 'Import Spine description'! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 11:55'!
modelForTextualDescription: string
	"parse string and fill up a moose model. string has to correspond to a program"
	
	| model program collectingVisitor |
	
	"Make sure that the code is parseable"
	self assert: [ self isParseable: string ] description: 'Entered code is not parseable. Please check'.
	^ SPParser new 
		parse: string;
		resolve;
		mooseModel! !

!SPTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 11:53'!
processFileNamed: fileName
	| file |
	[file := FileStream fileNamed: fileName.
	self processText: file contents titled: file localName ]
		on: Error do: [ :ex | 
			UIManager default inform: ex printString.
			file ifNotNil: [ file close ] ] ! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 11:53'!
processText: str
	self processText: str titled: 'no name'! !

!SPTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 11/23/2012 11:53'!
processText: str titled: title
	(str notNil and: [ str notEmpty ])
			ifTrue: [ MooseModel root add: ((self modelForTextualDescription: str) name: title) ]! !

Object subclass: #FMParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

FMParser subclass: #FMASTBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:31'!
children
	^ super children ==> [ :node | node flatten ]! !

!FMASTBuilder methodsFor: 'public' stamp: 'AlexandreBergel 7/7/2012 14:17'!
constraint
	| term prim |
	
	term := PPDelegateParser new.
	prim := PPDelegateParser new.
	
	term setParser: ((self fmlIdentifier trim,  self constraintOperator , prim) ==> [ :n |  n second new left: n first ; right: n third; yourself  ] ) /
					(($!! asParser trim, self fmlIdentifier trim,  self constraintOperator , prim) ==> [ :n |  n third new left: (FMConstraintNegated new expr: n second) ; right: n fourth; yourself  ]) /

					((prim trim,  self constraintOperator , prim) ==> [ :n |  n second new left: n first ; right: n third; yourself  ] ) / 
					prim.
	prim setParser: 
		
		($( asParser trim , term , $) asParser trim ==> [ :n | n second ]) /
		(($!! asParser trim, term) ==> [ :n | FMConstraintNegated new expr: n second ]) /
		(self fmlIdentifier trim ==> [ :n | n ]) 
				.

	^ term! !

!FMASTBuilder methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 17:23'!
constraintOperator
	^ ( '|'  asParser trim / 
						 'or'  asParser trim / 
						 'and'  asParser trim / 
						'&' asParser trim / 
						'->' asParser trim  /  
						'<->' asParser trim) ==> [ :n | FMConstraintBinOp for: n ] ! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 14:39'!
featureModel
	^ super featureModel ==> [ :node | 
		| prods cons fm |
		prods := node third collect: #first. 
		cons := node fourth flatten reject: [ :n | n = $; ]. 
		
		fm := FMFeatureModel new 
			addAllExpressions: prods;
			addAllConstraints: cons;
			yourself.
		fm features do: [ :f | f featureModel: fm ].
		fm ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 10:56'!
fmlIdentifier
	^ super fmlIdentifier ==> [ :node | FMFeature new name: node ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:26'!
mandatory
	^ super mandatory ==> [ :node | Array with: (FMFeatureMendatory new feature: node) ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:27'!
mutexgroup
	^ super mutexgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureMutex new feature: n ] ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:28'!
optional
	^ super optional ==> [ :node |  Array with: (FMFeatureOptional new feature: node second) ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:21'!
orgroup
	^ super orgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureOr new feature: n ] ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:58'!
production
	^ super production ==> [ :nodes | 
		FMFeatureProduction new 
			root: nodes first ; 
			addAll: nodes third ; 
			yourself ]
! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:59'!
xorgroup
	^ super xorgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureXor new feature: n ] ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:05'!
child
	^ self mandatory / self orgroup / self mutexgroup / self optional / self xorgroup ! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 10:56'!
children
	^ self child plus! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 17:20'!
constraint
	| term prim |
	
	term := PPDelegateParser new.
	prim := PPDelegateParser new.
	
	term setParser: ( prim,  ( 'or' asParser trim / 'and' asParser trim / '|'  asParser trim / '&' asParser trim / '->' asParser trim  /  '<->' asParser trim ) , prim) / 
					prim.
	prim setParser: ($( asParser trim , term , $) asParser trim) /
					($!! asParser trim, term) /
				self id.
					
	^ term! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:22'!
featureModel
	
	^ 'FM' asParser trim , self leftPar ,  ((self production  , self semiColumn ) plus) ,  (self constraint  , self semiColumn ) star , self rightPar
! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/3/2012 16:07'!
fmlIdentifier
	^ (#letter asParser , ( #letter asParser / #digit asParser / $_ asParser) star) flatten trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 11:03'!
id
	^  (#letter asParser , ( #letter asParser / #digit asParser ) star) flatten trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 6/30/2012 22:13'!
leftPar 
	^ $( asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:47'!
mandatory
	"Mandatory   : name=ID ;
	ID : ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*; "
	
	^ self fmlIdentifier ! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:35'!
mutexgroup
	"Mutexgroup   : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN '?' ;"

	^ $( asParser , self fmlIdentifier  , ( $| asParser , self fmlIdentifier ) plus ,  $) asParser , $? asParser! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 11:51'!
optional
	"Optional    : '[' name=FML_IDENTIFIER ']' ;"
	^ '[' asParser trim , self fmlIdentifier , ']' asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:35'!
orgroup
	"Orgroup    : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN '+' ;"

	^ self leftPar  , self fmlIdentifier , ( self verticalBar  , self fmlIdentifier ) plus ,  self rightPar  , $+ asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 10:56'!
production
	^ (self fmlIdentifier ,  ':' asParser trim , self children) trim! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:06'!
program
	^ self statement star ==> [ :node | FMProgram new addAll: node ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 6/30/2012 22:14'!
rightPar 
	^ $) asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 01:59'!
semiColumn
	^ $; asParser trim! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:05'!
statement
	^ (self id , $= asParser trim, self featureModel) ==>
			 [ :node | FMAssignment new variable: node first; featureModel: node third ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 01:58'!
verticalBar 
	^ $| asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:03'!
xorgroup
	"Xorgroup   : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN ;"

	^ self leftPar , self fmlIdentifier , ( self verticalBar , self fmlIdentifier ) plus ,  self rightPar! !

Object subclass: #FMVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

FMVisitor subclass: #CollectingVisitor
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 14:31'!
constains: object
	^ elements includes: object! !

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:27'!
elements
	^ elements asSet asOrderedCollection! !

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 15:06'!
elementsOfKind: aClass
	^ self elements select: [ :el | el isKindOf: aClass ]! !

!CollectingVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 00:22'!
initialize 
	super initialize.
	elements := OrderedCollection new ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitAssigment: aFMAssignment 
	elements add: aFMAssignment ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 17:02'!
visitConstraintAnd: aFMConstraintAnd 
	elements add: aFMConstraintAnd ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:38'!
visitConstraintArrow: aFMConstraintArrow 
	elements add: aFMConstraintArrow ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
visitConstraintEquiv: aFMConstraintEquiv
	elements add: aFMConstraintEquiv ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:38'!
visitConstraintNegated: aFMConstraintNegated 
	elements add: aFMConstraintNegated ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:15'!
visitConstraintPipe: aFMConstraintPipe
	elements add: aFMConstraintPipe ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 14:26'!
visitFeature: aFMFeature 
	elements add: aFMFeature ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitFeatureModel: aFMFeatureModel 
	elements add: aFMFeatureModel ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitProgram: aFMProgram 
	elements add: aFMProgram ! !

FMVisitor subclass: #CountingFeatureVisitor
	instanceVariableNames: 'features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!CountingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:18'!
features 
	^ features asArray! !

!CountingFeatureVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 10:49'!
initialize
	super initialize.
	features := OrderedCollection new.! !

!CountingFeatureVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 11/23/2012 09:48'!
visitFeature: aFMFeature 
	(features anySatisfy: [ :f | f name = aFMFeature name ] )
		ifFalse: [ features add: aFMFeature ]! !

FMVisitor subclass: #FMCollectingFeatureVisitor
	instanceVariableNames: 'featuresImplying featuresImplied focusedFeature exclusions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/6/2012 16:44'!
exclusions
	^ exclusions asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:35'!
featuresImplied
	^ featuresImplied asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:34'!
featuresImplying
	^ featuresImplying asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:22'!
focusedFeature
	^ focusedFeature! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:22'!
focusedFeature: anObject
	focusedFeature := anObject! !

!FMCollectingFeatureVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/6/2012 16:19'!
initialize 
	super initialize.
	featuresImplying := OrderedCollection new.
	featuresImplied := OrderedCollection new.
	exclusions := OrderedCollection new! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/7/2012 14:17'!
visitConstraintArrow: aFMConstraintArrow 
	| c featuresRight featuresLeft |

"self halt."

	"We ignore not on the left hand side"
	(aFMConstraintArrow left class == FMConstraintNegated) ifTrue: [ ^ self ].

	"We get what features is on the left hand side"
	c := CollectingVisitor new.
	aFMConstraintArrow left accept: c.
	featuresLeft := c elementsOfKind: FMFeature. 

	"We get what features is on the right hand side"
	c := CollectingVisitor new.
	aFMConstraintArrow right accept: c.
	featuresRight := c elementsOfKind: FMFeature. 


	(aFMConstraintArrow right class == FMConstraintNegated) 
		ifTrue: [
			(featuresRight includes: focusedFeature) ifTrue: [ exclusions addAll: featuresLeft ].
			(featuresLeft includes: focusedFeature) ifTrue: [ exclusions addAll: featuresRight ] ]
		ifFalse: [
			(featuresRight includes: focusedFeature) ifTrue: [ featuresImplied addAll: featuresLeft ].
			(featuresLeft includes: focusedFeature) ifTrue: [ featuresImplying addAll: featuresRight ] ]
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:15'!
visitAssigment: aFMAssignment 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/4/2012 16:46'!
visitConstraintAnd: aFMConstraintAnd 
! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:13'!
visitConstraintArrow: aFMConstraintArrow 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
visitConstraintEquiv: aFMConstraintEquiv 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/2/2012 13:30'!
visitConstraintNegated: aFMConstraintNegated 
! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:15'!
visitConstraintPipe: aFMConstraintPipe 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:13'!
visitFeature: aFMFeature 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:17'!
visitFeatureModel: aFMFeatureModel 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:14'!
visitProgram: aFMProgram 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:16'!
visitVariable: aVariable 
	! !

Object subclass: #SPParser
	instanceVariableNames: 'mooseModel features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPParser commentStamp: 'AlexandreBergel 11/23/2012 11:49' prior: 0!
(SPParser new parse: (SPParserTest new trace1)) mooseModel visualizeSPINE
!

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/22/2012 09:17'!
assertBeginWithTag: string
	(self doesBeginWithTag: string)
		ifFalse: [ self error: 'Improper tag' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:49'!
assertContainsBeginStatement: lines
	(self containsBeginStatement: lines)
		ifFalse: [ self error: 'Missing begin statement' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:50'!
assertContainsEndingStatement: lines
	(self containsEndingStatement: lines)
		ifFalse: [ self error: 'Missing ending statement' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:48'!
containsBeginStatement: lines
	^ lines anySatisfy: [ :line | line = '[ROASSAL] BEGIN MODEL' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:48'!
containsEndingStatement: lines
	^ lines anySatisfy: [ :line | line = '[ROASSAL] END MODEL' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/22/2012 09:17'!
doesBeginWithTag: string
	^ string beginsWith: '[ROASSAL] '! !

!SPParser methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 10:56'!
getIdFrom: featureModelString
	"Extract the id in a string"
	
	^ self getValueNamed: 'id' from: featureModelString! !

!SPParser methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 11:31'!
getListNamed: keyName from: stringToExtractFrom 
	| indexKey endingWhiteSpaceIndex str |
	indexKey := (stringToExtractFrom indexOfSubCollection: (' ', keyName, '=')) + 1.
	endingWhiteSpaceIndex := stringToExtractFrom indexOf: $  startingAt: indexKey ifAbsent: [ stringToExtractFrom size + 1].

	( (stringToExtractFrom at: (indexKey + keyName size)) = $= ) ifFalse: [ self error: 'Unexpected character for key ', keyName ].
	
	((stringToExtractFrom at: (indexKey + keyName size + 1)) = $[)
		ifTrue: [ 
			((indexKey + keyName size + 1) = (endingWhiteSpaceIndex -2 ))
				ifTrue: [ ^ #() ].
			
			(indexKey + keyName size + 2) >= (endingWhiteSpaceIndex - 2)
				ifTrue: [ self error: 'key ', keyName , ' not found' ].
				
			str := stringToExtractFrom copyFrom: (indexKey + keyName size + 2)  to: (endingWhiteSpaceIndex - 2).
			^ str subStrings: ',' ]
		
		ifFalse: [
			^ stringToExtractFrom copyFrom: (indexKey + keyName size + 1)  to: (endingWhiteSpaceIndex - 1) ]
	! !

!SPParser methodsFor: 'util' stamp: 'AlexandreBergel 11/23/2012 10:55'!
getValueNamed: keyName from: stringToExtractFrom
	| indexKey endingClosingIndex str |
	indexKey := stringToExtractFrom indexOfSubCollection: keyName.
	endingClosingIndex := stringToExtractFrom indexOf: $" startingAt: (indexKey + keyName size + 2).

	self assert: [ (stringToExtractFrom at: (indexKey + keyName size)) = $= ].
	self assert: [ (stringToExtractFrom at: (indexKey + keyName size + 1)) = $" ].
	
	^ stringToExtractFrom copyFrom: (indexKey + keyName size + 2)  to: (endingClosingIndex - 1)
	! !

!SPParser methodsFor: 'initialize' stamp: 'AlexandreBergel 11/22/2012 09:48'!
initialize
	super initialize.
	mooseModel := MooseModel new.! !

!SPParser methodsFor: 'private' stamp: 'SimonUrli 11/23/2012 14:52'!
mooseModel 

^mooseModel ! !

!SPParser methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 12:25'!
parse: aString
	"Public method"

	^ self parseLines: aString lines ! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/21/2012 17:48'!
parseActionDeselect: actionDeselectString

	| actionDeselect | 
	self assertBeginWithTag: actionDeselectString.

	actionDeselect := SPActionDeselect new
						name: (self getIdFrom: actionDeselectString);
						feature: (self getListNamed: 'feature' from: actionDeselectString);
						fm: (self getListNamed: 'fm' from: actionDeselectString);
						yourself.
						
	^ actionDeselect 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/21/2012 17:52'!
parseActionSelect: actionDeselectString

	| actionDeselect | 
	self assertBeginWithTag: actionDeselectString.

	^ SPActionSelect new
						name: (self getIdFrom: actionDeselectString);
						feature: (self getListNamed: 'feature' from: actionDeselectString);
						fm: (self getListNamed: 'fm' from: actionDeselectString);
						yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:15'!
parseBEGIN: ruleString

	| actionDeselect | 
	self assertBeginWithTag: ruleString.

	! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 08:55'!
parseConfigurationState: configurationStateString

	| actionDeselect | 
	self assertBeginWithTag: configurationStateString.

	^ SPConfigurationState new
				name: (self getIdFrom: configurationStateString);
				fm: (self getListNamed: 'fm' from: configurationStateString);
				selected: (self getListNamed: 'selected' from: configurationStateString);
				deselected: (self getListNamed: 'deselected' from: configurationStateString);
				yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:18'!
parseDEAEnd: string
	^ self parseDomainElementEnd: string! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:04'!
parseDEAssociation: deAssociationString

	| actionDeselect | 
	self assertBeginWithTag: deAssociationString.

	^ SPDEAssociation new
				name: (self getIdFrom: deAssociationString);
				source: (self getListNamed: 'source' from: deAssociationString);
				target: (self getListNamed: 'target' from: deAssociationString);
				restrictionFunctions: (self getListNamed: 'restrictionFunctions' from: deAssociationString);
				yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/21/2012 17:54'!
parseDomainElement: domainElementString

	| domainElement | 
	self assertBeginWithTag: domainElementString.

	domainElement := SPDomainElement new
						name: (self getIdFrom: domainElementString);
						belongsTo: (self getListNamed: 'belongs_to' from: domainElementString);
						refersOn: (self getListNamed: 'refers_on' from: domainElementString);
						multiplicityElement: (self getListNamed: 'MultiplicityElement' from: domainElementString);
						yourself.
						
	^ domainElement 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/21/2012 17:38'!
parseDomainElementEnd: domainElementEndString

	| domainElementEnd | 
	self assertBeginWithTag: domainElementEndString.

	domainElementEnd := SPDomainElementEnd new
						name: (self getIdFrom: domainElementEndString);
						applyOn: (self getListNamed: 'apply_on' from: domainElementEndString);
						linkMultiplicity: (self getListNamed: 'linkMultiplicity' from: domainElementEndString);
						yourself.
						
	^ domainElementEnd
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:15'!
parseEND: ruleString

	| actionDeselect | 
	self assertBeginWithTag: ruleString.

	! !

!SPParser methodsFor: 'specific' stamp: 'SimonUrli 11/23/2012 21:36'!
parseFeature: featureString
	self assertBeginWithTag: featureString.

	^ SPFeature new
						name: (self getIdFrom: featureString);
						shortName: (self getValueNamed: 'name' from: featureString);
						yourself.
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/23/2012 10:57'!
parseFeatureModel: featureModelString
	| featureName fmFamiliarString fmFeatureModel |
	self assertBeginWithTag: featureModelString.

	featureName := self getIdFrom: featureModelString.
	features := (self getListNamed: 'features' from: featureModelString).
	fmFamiliarString := (self getValueNamed:  'familiar' from: featureModelString).
	
	fmFeatureModel := FMASTBuilder new featureModel parse: fmFamiliarString.
	fmFeatureModel class == FMFeatureModel
		ifFalse: [ self error: 'Parsing error of the familiar feature model' ].
	^ SPFeatureModel new
		name: featureName;
		features: features;
		fmFeatureModel: fmFeatureModel;
		yourself! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/22/2012 09:17'!
parseLine: line
 	| kind |
	(self doesBeginWithTag: line)
		ifFalse: [ ^ self ].
		
	kind := line substrings second.
	^ self perform: ('parse', kind, ':') asSymbol withArguments: (Array with: line)! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/22/2012 09:49'!
parseLines: lines
	| v |
	self assertContainsBeginStatement: lines.
	lines do: [ :line | 
		v := self parseLine: line.
		(v ~~ self)
			ifTrue: [ mooseModel add: v ] ].
	self assertContainsEndingStatement: lines! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 08:44'!
parseMultiplicityElement: multiplicityElementString

	| actionDeselect | 
	self assertBeginWithTag: multiplicityElementString.

	^ SPMultiplicityElement new
				name: (self getIdFrom: multiplicityElementString);
				lowerBound: (self getListNamed: 'lowerBound' from: multiplicityElementString) asInteger;
				upperBound: (self getListNamed: 'upperBound' from: multiplicityElementString) asInteger;
				yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:11'!
parseRestrictionFunction: ruleString

	| actionDeselect | 
	self assertBeginWithTag: ruleString.

	^ SPRestrictionFunction new
				name: (self getIdFrom: ruleString);
				rules: (self getListNamed: 'rules' from: ruleString);
				yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/22/2012 09:01'!
parseRule: ruleString

	| actionDeselect | 
	self assertBeginWithTag: ruleString.

	^ SPRule new
				name: (self getIdFrom: ruleString);
				state: (self getListNamed: 'state' from: ruleString);
				actions: (self getListNamed: 'actions' from: ruleString);
				yourself.
						 
! !

!SPParser methodsFor: 'public' stamp: 'AlexandreBergel 11/22/2012 09:51'!
resolve

	mooseModel entities do: [ :e | e resolve ]! !
